
/************************************************************************

    JSWED 2.00 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"

class ConfigureForm : public VideoForm
{
protected:
	VideoTextEdit *m_edit;
	VideoButton   *m_ok, *m_cancel;
public:
	ConfigureForm(char *buf) : VideoForm(3 * CHAR_W, 12 * CHAR_H,
					    34 * CHAR_W,  8 * CHAR_H) 
	{
		m_edit = new VideoTextEdit(3*CHAR_W + CHAR_SW,
					  15*CHAR_H, 33*CHAR_W + 4, CHAR_H+4);
		m_edit->setLimit(PATH_MAX);
		m_edit->bind(buf);

	        m_ok = new VideoButton(ZXE_OK, 30 * CHAR_W, 17 * CHAR_H,
                     "  OK  ");
	        m_cancel = new VideoButton(ZXE_CANCEL, 22 * CHAR_W, 17 * CHAR_H,
                     "Cancel");

	}

	virtual ~ConfigureForm()
	{
		delete m_edit;
		delete m_ok;
		delete m_cancel;	
	}
        virtual void redraw(void)
	{
		VideoForm::redraw();
		videoScreen->box(m_x, m_y, m_w, m_h, ZX_BLACK);
	        videoScreen->drawText(m_x, m_y, "Configure JSWED          "
                              "         ", ZX_BRWHITE, ZX_BLACK);
	        videoScreen->zxLogo(m_x + m_w - 6 * CHAR_W, m_y);
		videoScreen->drawSmallText(m_x + CHAR_SW, m_y + 2 * CHAR_SH + 4,
		"Enter the full path to your Spectrum emulator - eg:", ZX_BLACK, ZX_WHITE);
		videoScreen->drawSmallText(m_x + CHAR_SW, m_y + 3 * CHAR_SH + 4,
#ifdef _WIN32
		"C:/WSPECEM/BINARIES/WSPECEM.EXE",
#else
		"/usr/local/bin/xzx -scale 2",
#endif
		ZX_BLACK, ZX_WHITE); 
	}
protected:
	virtual void hideChildren(void)
	{
		VideoForm::hideChildren();	
		removeChild(m_edit);
		removeChild(m_ok);
		removeChild(m_cancel);
	}
	virtual void showChildren(int redraw = 1)
	{
	        addChild(m_edit);
		addChild(m_ok);
		addChild(m_cancel);
		VideoForm::showChildren(redraw);
	}
};


int configure(void)
{
	char buf[PATH_MAX + 1];

	strcpy(buf, getSpectrumEmulator());
	ConfigureForm cfg(buf);

	int rv = cfg.doModal();

	if (rv == ZXE_OK) setSpectrumEmulator(buf);		
	return rv;	
}


