/************************************************************************

    JSWED 2.00 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"
#include "j48patchpage.hxx"
#include "j128game.hxx"
#include "filetypelist.hxx"

Jsw48PatchPage::Jsw48PatchPage(JswGame *g) : JswPatchPage(g)
{
	m_btnUpgrade = new VideoButton(101, 10 * CHAR_W, 20 * CHAR_H,
					"Convert to JSW128");
	m_btnUpgrade->setListener(this);	
	addChild(m_btnUpgrade);
}

Jsw48PatchPage::~Jsw48PatchPage()
{	
	delete m_btnUpgrade;
}

int Jsw48PatchPage::onCheckboxSelect(VideoCheckbox *b, int value)
{
	return JswPatchPage::onCheckboxSelect(b, value);
}

extern JswGame *gl_game;

int Jsw48PatchPage::onButtonSelect(VideoButton *b)
{
	if (b == m_btnUpgrade)
	{
		VideoMenu vm("Are you sure?", "Yes", "No", NULL);
		int rv = vm.doModal();
		
		if (rv >= ZXE_QUIT) return rv;
		if (vm.getSelected()) return ZXE_CONTINUE;

		m_game->m_upgrade = m_game->upgrade();

		if (!m_game->m_upgrade) return ZXE_CONTINUE;
		return ZXE_OK + 101;
	}
	return ZXE_CONTINUE;
}
