JSW_BIN_DIR = /usr/local/bin
JSW_LIB_DIR = /usr/local/lib/jswed
TMPDIR = /tmp
CROSS_COMPILER_ROOT = /usr/local/cross-tools/i386-mingw32

HEADERS = jswed.hxx snapio.hxx jswgame.hxx\
	  jfilelist.hxx jfilesel.hxx jnotebook.hxx \
	  bitmapedit.hxx \
	  j128game.hxx j48game.hxx henrygame.hxx \
          video.hxx bitmap.hxx menu.hxx event.hxx list.hxx filelist.hxx \
	  control.hxx form.hxx filesel.hxx notebook.hxx notepage.hxx \
	  textedit.hxx label.hxx button.hxx clrchooser.hxx checkbox.hxx \
	  spinctrl.hxx


ALLHEADERS = $(HEADERS) jswmsg.hxx j48msg.hxx j128msg.hxx j128mem.hxx j48roompage.hxx \
			j48sprite.hxx henryroompage.hxx \
			j128guard.hxx j128glist.hxx fixedguard.hxx hotspot.hxx \
			j128roomform.hxx j48udgsform.hxx j48clrsform.hxx \
			j48roomdraw.hxx j48roomnav.hxx j48telpage.hxx  \
			jswroomlist.hxx j48patchpage.hxx filetypelist.hxx \
			jswpatchpage.hxx j128patchpage.hxx henrypatchpage.hxx \
			upgrade.hxx j48splpage.hxx guardedit.hxx jswdirbox.hxx \
			j48attrpage.hxx j128attrpage.hxx henryattrpage.hxx \
			screenedit.hxx hotspotmgr.hxx sftxgame.hxx \
			sftxgame128.hxx geoffgame.hxx guardian.hxx \
			henrymsg.hxx spritelist.hxx vspritelist.hxx \
			fontedit.hxx letterchooser.hxx slistener.hxx \
			executor.hxx jswscr.hxx geoffguard.hxx j128gedit.hxx \
			geoffgedit.hxx hexedit.hxx sdl_video.hxx sdl_bitmap.hxx

# Group 1: Program
# Group 2: Video, device-independent
# Group 3: Video, device-dependent (uses SDL)

OBJECTS = jswed.o aboutbox.o utils.o jfilelist.o loadfile.o savefile.o \
	  snapio.o filetypelist.o jswgame.o jfilesel.o jnotebook.o \
	  spritelist.o vspritelist.o bitmapedit.o jswdirbox.o hexedit.o \
	  henrygame.o j48game.o j128game.o sftxgame.o sftxgame128.o \
	  jswmsg.o j48msg.o j128msg.o j128mem.o j48sprite.o j48roomdraw.o \
	  j48roomnav.o j48roompage.o henryroompage.o \
	  j48udgsform.o j48clrsform.o j48telpage.o jswroomlist.o \
	  j48patchpage.o jswpatchpage.o j128patchpage.o henrypatchpage.o \
	  j128guard.o fixedguard.o hotspot.o j128glist.o j128roomform.o \
	  upgrade.o upgradedata.o j48splpage.o guardedit.o henrymsg.o \
	  fontedit.o letterchooser.o j48attrpage.o j128attrpage.o \
	  henryattrpage.o screenedit.o hotspotmgr.o configure.o \
	  geoffgame.o guardian.o geoffguard.o j128gedit.o geoffgedit.o \
	menu.o filesel.o filelist.o list.o uiutils.o video.o vidfont.o \
	notebook.o notepage.o form.o control.o textedit.o label.o \
	button.o clrchooser.o checkbox.o spinctrl.o \
	  sdl_video.o sdl_bitmap.o sdl_event.o  sdl_executor.o \

CSOURCE = aboutbox.cxx	   henrypatchpage.cxx  j48roompage.cxx	  savefile.cxx \
	bitmapedit.cxx	   henryroompage.cxx   j48splpage.cxx	  screenedit.cxx \
	button.cxx	   hexedit.cxx	       j48sprite.cxx	  sdl_bitmap.cxx \
	checkbox.cxx	   hotspot.cxx	       j48telpage.cxx	  sdl_event.cxx \
	clrchooser.cxx	   hotspotmgr.cxx      j48udgsform.cxx	  sdl_executor.cxx \
	configure.cxx	   j128attrpage.cxx    jfilelist.cxx	  sdl_video.cxx \
	control.cxx	   j128game.cxx        jfilesel.cxx	  sftxgame.cxx \
	filelist.cxx	   j128gedit.cxx       jnotebook.cxx	  sftxgame128.cxx \
	filesel.cxx	   j128glist.cxx       jswdirbox.cxx	  snapio.cxx \
	filetypelist.cxx   j128guard.cxx       jswed.cxx	  spinctrl.cxx \
	fixedguard.cxx	   j128mem.cxx	       jswgame.cxx	  spritelist.cxx \
	fontedit.cxx	   j128msg.cxx	       jswmsg.cxx	  textedit.cxx \
	form.cxx	   j128patchpage.cxx   jswpatchpage.cxx   uiutils.cxx \
	geoffgame.cxx	   j128roomform.cxx    jswroomlist.cxx	  upgrade.cxx \
	geoffgedit.cxx	   j48attrpage.cxx     label.cxx	  upgradedata.cxx \
	geoffguard.cxx	   j48clrsform.cxx     letterchooser.cxx  utils.cxx \
	guardedit.cxx	   j48game.cxx	       list.cxx		  video.cxx \
	guardian.cxx	   j48msg.cxx	       loadfile.cxx	  vidfont.cxx \
	henryattrpage.cxx  j48patchpage.cxx    menu.cxx		  vspritelist.cxx \
	henrygame.cxx	   j48roomdraw.cxx     notebook.cxx \
	henrymsg.cxx	   j48roomnav.cxx      notepage.cxx 

DOCS = jswed.lyx jswed.ps jswed.pdf README INSTALL.txt COPYING copying.txt

BUILD = build/unix/Makefile build/win32/Makefile Install/JSWED.bmp \
	Install/JSWED_L.bmp Install/jswed.iwz makedefs.i Makefile

XBM =   bottomscr.xbm  diag1.xbm  diag3.xbm  left.xbm    right.xbm   tick.xbm \
	diag0.xbm      diag2.xbm  down.xbm   pencil.xbm  shaded.xbm  up.xbm \
	zxfont.inc


SOURCE = $(ALLHEADERS) $(CSOURCE) $(BUILD) $(DOCS) $(XBM) Lib/*

