/************************************************************************

    JSWED 2.00 - Editor for Jet Set Willy and derivatives

    Copyright (C) 2000-2001  John Elliott <jce@seasip.demon.co.uk>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

*************************************************************************/

#include "jswed.hxx"
#include "upgrade.hxx"

#define BEGINPATCH(x) unsigned short patch_##x [] = { 
#define ENDPATCH 0,0};

//
// Patches for JSW48->JSW128
//

BEGINPATCH(1)
        0x840C, 195 ,   /* Jump to initialisation: Disable password checks, */
        0x840D, 202 ,   /* just in case */
        0x840E, 135 ,
        0x8420, 33 ,    /* Willy's location */
        0x8484, 49 ,    /* Scrolling message */
        0x8485, 50 ,
        0x8486, 56 ,
        0x8487, 107 ,
        0x8488, 32 ,
        0x8489, 86 ,
        0x848A, 101 ,
        0x848B, 114 ,
        0x848C, 115 ,
        0x848D, 105 ,
        0x848E, 111 ,
        0x848F, 110 ,
        0x8490, 32 ,
        0x8491, 48 ,
        0x8492, 46 ,
        0x8493, 48 ,
        0x8494, 243 ,
        0x8495, 1 ,
        0x8496, 253 ,
        0x8497, 127 ,
        0x8498, 62 ,
        0x8499, 23 ,
        0x849A, 237 ,
        0x849B, 121 ,
        0x849C, 42 ,
        0x849D, 208 ,
        0x849E, 132 ,
        0x849F, 17 ,
        0x84A0, 116 ,
        0x84A1, 132 ,
        0x84A2, 1 ,
        0x84A3, 32 ,
        0x84A4, 0 ,
        0x84A5, 237 ,
        0x84A6, 176 ,
        0x84A7, 126 ,
        0x84A8, 245 ,
        0x84A9, 1 ,
        0x84AA, 253 ,
        0x84AB, 127 ,
        0x84AC, 62 ,
        0x84AD, 16 ,
        0x84AE, 237 ,
        0x84AF, 121 ,
        0x84B0, 241 ,
        0x84B1, 183 ,
        0x84B2, 40 ,
        0x84B3, 16 ,
        0x84B4, 42 ,
        0x84B5, 208 ,
        0x84B6, 132 ,
        0x84B7, 35 ,
        0x84B8, 34 ,
        0x84B9, 208 ,
        0x84BA, 132 ,
        0x84BB, 58 ,
        0x84BC, 228 ,
        0x84BD, 133 ,
        0x84BE, 230 ,
        0x84BF, 127 ,
        0x84C0, 50 ,
        0x84C1, 228 ,
        0x84C2, 133 ,
        0x84C3, 201 ,
        0x84C4, 33 ,
        0x84C5, 0 ,
        0x84C6, 214 ,
        0x84C7, 34 ,
        0x84C8, 208 ,
        0x84C9, 132 ,
        0x84CA, 62 ,
        0x84CB, 223 ,
        0x84CC, 50 ,
        0x84CD, 228 ,
        0x84CE, 133 ,
        0x84CF, 201 ,
        0x84D0, 0 ,
        0x84D1, 214 ,
        ENDPATCH    /* End Of Patch 1 */

BEGINPATCH(2)
	0x858B, 58 ,
	0x858C, 32 ,
	0x858D, 132 ,
	0x858E, 30 ,
	0x858F, 1 ,
	0x8590, 254 ,
	0x8591, 64 ,
	0x8592, 56 ,
	0x8593, 13 ,
	0x8594, 30 ,
	0x8595, 3 ,
	0x8596, 254 ,
	0x8597, 128 ,
	0x8598, 56 ,
	0x8599, 7 ,
	0x859A, 28 ,
	0x859B, 254 ,
	0x859C, 192 ,
	0x859D, 56 ,
	0x859E, 2 ,
	0x859F, 30 ,
	0x85A0, 6 ,
	0x85A1, 1 ,
	0x85A2, 253 ,
	0x85A3, 127 ,
	0x85A4, 243 ,
	0x85A5, 237 ,
	0x85A6, 89 ,
	0x85A7, 246 ,
	0x85A8, 192 ,
	0x85A9, 103 ,
	0x85AA, 46 ,
	0x85AB, 0 ,
	0x85AC, 17 ,
	0x85AD, 0 ,
	0x85AE, 128 ,
	0x85AF, 1 ,
	0x85B0, 0 ,
	0x85B1, 1 ,
	0x85B2, 237 ,
	0x85B3, 176 ,
	0x85B4, 1 ,
	0x85B5, 253 ,
	0x85B6, 127 ,
	0x85B7, 62 ,
	0x85B8, 16 ,
	0x85B9, 237 ,
	0x85BA, 121 ,
	0x85BB, 237 ,
	0x85BC, 87 ,
	0x85BD, 254 ,
	0x85BE, 62 ,
	0x85BF, 40 ,
	0x85C0, 1 ,
	0x85C1, 251 ,
	0x85C2, 195 ,   // These 4 bytes will be overwritten
	0x85C3, 33,	// by the superjump patch applied later.
	0x85C4, 137,
	0x85C5, 32,

	0x85CC, 7 ,	/* Lives */
	0x85CF, 208 ,	/* Willy Y, X */
	0x85D3, 180 ,
	0x85D4, 93 ,
	0x85DE, 173 ,	/* Items to collect */
	0x85E2, 1 ,
	0x85E4, 224 ,	/* Scrolling message pos */

        0x8912, 195 ,   /* Read 128k room data */
        0x8913, 139 ,
        0x8914, 133 ,
ENDPATCH

BEGINPATCH(3)
	0x85FC, 62 ,	// 128k music
	0x85FD, 8 ,
	0x85FE, 50 ,
	0x85FF, 251 ,
	0x8600, 133 ,
	0x8601, 62 ,
	0x8602, 248 ,
	0x8603, 237 ,
	0x8604, 71 ,
	0x8605, 251 ,
	0x8606, 118 ,
	0x8607, 243 ,
	0x8608, 33 ,
	0x8609, 0 ,
	0x860A, 247 ,
	0x860B, 17 ,
	0x860C, 142 ,
	0x860D, 254 ,
	0x860E, 1 ,
	0x860F, 6 ,
	0x8610, 0 ,
	0x8611, 237 ,
	0x8612, 176 ,
	0x8613, 175 ,
	0x8614, 50 ,
	0x8615, 251 ,
	0x8616, 133 ,
	0x8617, 205 ,
	0x8618, 0 ,
	0x8619, 250 ,
	0x861A, 251 ,
	0x861B, 195 ,
	0x861C, 252 ,
	0x861D, 136 ,
	0x861E, 62 ,
	0x861F, 8 ,
	0x8620, 50 ,
	0x8621, 251 ,
	0x8622, 133 ,
	0x8623, 33 ,
	0x8624, 0 ,
	0x8625, 64 ,
	0x8626, 201 ,
	0x8627, 0 ,	/* Spare */
	0x8628, 0 ,
	0x8629, 0 ,
	0x862A, 0 ,
	0x862B, 0 ,
	0x862C, 0 ,
	0x862D, 0 ,
	0x862E, 0 ,
	0x862F, 0 ,

	0x8B3B, 25 ,
	0x8B3C, 237 ,
	0x8B3D, 87 ,
	0x8B3E, 254 ,
	0x8B3F, 62 ,
	0x8B40, 32 ,
	0x8B41, 19 ,
	0x8B42, 33 ,
	0x8B43, 0 ,
	0x8B44, 247 ,
	0x8B45, 17 ,
	0x8B46, 142 ,
	0x8B47, 254 ,
	0x8B48, 1 ,
	0x8B49, 6 ,
	0x8B4A, 0 ,
	0x8B4B, 237 ,
	0x8B4C, 176 ,
	0x8B4D, 175 ,
	0x8B4E, 50 ,
	0x8B4F, 251 ,
	0x8B50, 133 ,
	0x8B51, 205 ,
	0x8B52, 0 ,
	0x8B53, 250 ,
	0x8B54, 251 ,
	0x8B55, 175 ,
	0x8B56, 50 ,
	0x8B57, 224 ,
	0x8B58, 133 ,
	0x8B59, 58 ,
	0x8B5A, 225 ,
	0x8B5B, 133 ,
	0x8B5C, 60 ,
	0x8B5D, 50 ,
	0x8B5E, 225 ,
	0x8B5F, 133 ,
	0x8B60, 58 ,
	0x8B61, 226 ,
	0x8B62, 133 ,
	0x8B63, 230 ,
	0x8B64, 2 ,
	0x8B65, 40 ,
	0x8B66, 9 ,
	0x8B67, 62 ,
	0x8B68, 8 ,
	0x8B69, 50 ,
	0x8B6A, 251 ,
	0x8B6B, 133 ,
	0x8B6C, 0 ,
	0x8B6D, 0 ,
	0x8B6E, 0 ,
	0x8B6F, 0 ,
	0x8C4A, 205 ,
	0x8C4B, 30 ,
	0x8C4C, 134 ,
ENDPATCH


BEGINPATCH(4)
	0x869F, 124 ,	// 8-bit room numbers in object table
	0x86A0, 198 ,
	0x86A1, 28 ,
	0x86A2, 103 ,
	0x86A3, 78 ,
	0x86A4, 214 ,
	0x86A5, 28 ,
	0x86A6, 103 ,
	0x86A7, 58 ,
	0x86A8, 32 ,
	0x86A9, 132 ,
	0x86AA, 185 ,
	0x86AB, 245 ,
	0x86AC, 78 ,
	0x86AD, 203 ,
	0x86AE, 185 ,
	0x86AF, 241 ,
	0x86B0, 194 ,
	0x86B1, 82 ,
	0x86B2, 148 ,
	0x86B3, 203 ,
	0x86B4, 113 ,
	0x86B5, 202 ,
	0x86B6, 82 ,
	0x86B7, 148 ,
	0x86B8, 195 ,
	0x86B9, 226 ,
	0x86BA, 147 ,
	0x93D7, 195 ,
	0x93D8, 159 ,
	0x93D9, 134 ,
	0x93DA, 0 ,
	0x93DB, 0 ,
	0x93DC, 0 ,
	0x93DD, 0 ,
	0x93DE, 0 ,
	0x93DF, 0 ,
ENDPATCH


BEGINPATCH(5)
	0x86BB, 230 ,	// 8-bit room numbers for WRITETYPER 
	0x86BC, 28 ,
	0x86BD, 238 ,
	0x86BE, 28 ,
	0x86BF, 7 ,
	0x86C0, 7 ,
	0x86C1, 7 ,
	0x86C2, 201 ,
	0x87C0, 0 ,
	0x87C1, 0 ,
	0x87C2, 0 ,
	0x87C4, 0 ,
	0x87C5, 193 ,
	0x87C6, 193 ,
	0x87C7, 195 ,
	0x87C8, 142 ,
	0x87C9, 133 ,

	0x8B7A, 205 ,
	0x8B7B, 187 ,
	0x8B7C, 134 ,
	0x8B7D, 0 ,
	0x8B7E, 0 ,
ENDPATCH


BEGINPATCH(6)
	0x881B, 26 ,	// LDIR title screen in from bank 7 rather
	0x8826, 0 ,	// than generating it; and other changes.
	0x8827, 0 ,
	0x8841, 243 ,
	0x8842, 62 ,
	0x8843, 23 ,
	0x8844, 1 ,
	0x8845, 253 ,
	0x8846, 127 ,
	0x8847, 237 ,
	0x8848, 121 ,
	0x8849, 197 ,
	0x884A, 33 ,
	0x884B, 0 ,
	0x884C, 192 ,
	0x884D, 17 ,
	0x884E, 0 ,
	0x884F, 64 ,
	0x8850, 1 ,
	0x8851, 0 ,
	0x8852, 16 ,
	0x8853, 237 ,
	0x8854, 176 ,
	0x8855, 17 ,
	0x8856, 0 ,
	0x8857, 96 ,
	0x8858, 1 ,
	0x885A, 6 ,
	0x885B, 237 ,
	0x885C, 176 ,
	0x885D, 193 ,
	0x885E, 62 ,
	0x885F, 16 ,
	0x8860, 237 ,
	0x8861, 121 ,
	0x8862, 243 ,
	0x8863, 33 ,
	0x8864, 0 ,
	0x8865, 96 ,
	0x8866, 17 ,
	0x8867, 0 ,
	0x8868, 88 ,
	0x8869, 1 ,
	0x886A, 0 ,
	0x886B, 2 ,
	0x886C, 237 ,
	0x886D, 176 ,
	0x886E, 33 ,
	0x886F, 42 ,
	0x8870, 236 ,
	0x8871, 17 ,
	0x8872, 42 ,
	0x8873, 117 ,
	0x8874, 1 ,
	0x8875, 214 ,
	0x8876, 10 ,
	0x8877, 237 ,
	0x8878, 176 ,
	0x8879, 33 ,
	0x887A, 42 ,
	0x887B, 117 ,
	0x887C, 17 ,
	0x887D, 142 ,
	0x887E, 254 ,
	0x887F, 1 ,
	0x8880, 6 ,
	0x8881, 0 ,
	0x8882, 237 ,
	0x8883, 176 ,
	0x8884, 175 ,
	0x8885, 50 ,
	0x8886, 251 ,
	0x8887, 133 ,
	0x8888, 205 ,
	0x8889, 0 ,
	0x888A, 250 ,
	0x888B, 175 ,
	0x888C, 211 ,
	0x888D, 254 ,
	0x888E, 0 ,
	0x888F, 0 ,
	0x8890, 0 ,
	0x8891, 0 ,
	0x8892, 0 ,
	0x8893, 0 ,
	0x8894, 0 ,
	0x8898, 251 ,
	0x88B0, 133 ,
	0x88C8, 205 ,
	0x88C9, 148 ,
	0x88CA, 132 ,
	0x88CB, 221 ,
	0x88CC, 33 ,
	0x88CD, 116 ,
	0x88CE, 132 ,
	0x88CF, 0 ,
	0x88D0, 0 ,
	0x88ED, 192 ,

	0x96A2, 0 ,
	0x96A3, 33 ,
	0x96A4, 0 ,
	0x96A5, 96 ,
	0x96A6, 17 ,
	0x96A7, 0 ,
	0x96A8, 88 ,
	0x96A9, 1 ,
	0x96AA, 0 ,
	0x96AB, 2 ,
	0x96AC, 237 ,
	0x96AD, 176 ,
	0x96AE, 6 ,
	0x96AF, 10 ,
	0x96B0, 237 ,
	0x96B1, 87 ,
	0x96B2, 254 ,
	0x96B3, 62 ,
	0x96B4, 200 ,
	0x96B5, 118 ,
	0x96B6, 16 ,
	0x96B7, 248 ,
	0x96B8, 0 ,
	0x96B9, 0 ,
	0x96BA, 0 ,
	0x96BB, 124 ,
	0x96BC, 254 ,
	0x96BD, 102 ,
	0x96BE, 32 ,
	0x96BF, 2 ,
	0x96C0, 38 ,
	0x96C1, 96 ,
	0x96C6, 195 ,
	0x96C7, 166 ,
	0x96C8, 150 ,
ENDPATCH


BEGINPATCH(7)
        0x85C2, 33 ,    // Superjump
        0x85C3, 222 ,   
        0x85C4, 128 , 
        0x85C5, 17 ,   
        0x85C6, 52,
        0x85C7, 142,
        0x85C8, 195,
        0x85C9, 21,
        0x85CA, 137,

        0x8915, 62 ,
        0x8916, 188,
        0x8917, 18,
        0x8918, 203,
        0x8919, 126,
        0x891A, 40,
        0x891B, 3,
        0x891C, 62,
        0x891D, 44,
        0x891E, 18,
        0x891F, 203,
        0x8920, 190,
        0x8921, 0,
ENDPATCH


BEGINPATCH(8)
	0x8931, 0 ,	// Multiple guardian tables
	0x8932, 205 ,
	0x8933, 182 ,
	0x8934, 196 ,
ENDPATCH

BEGINPATCH(9)
	0x8992, 195 ,	// Boot in status line 
	0x8993, 0 ,
	0x8994, 235 ,

ENDPATCH


BEGINPATCH(10)		// Keys that work PAUSE
	0x8AC9, 1 ,
	0x8ACB, 1 ,
ENDPATCH

BEGINPATCH(11)		// Willy sprite override 
        0x9650, 95 ,
        0x9651, 22 ,
        0x9652, 157,
        0x9653, 58 ,
        0x9654, 237 ,
        0x9655, 128 ,
        0x9656, 254,
        0x9657, 128 ,
        0x9658, 56 ,
        0x965A, 87 ,
        0x965B, 0 ,
ENDPATCH

BEGINPATCH(12)		// Pause bug fix
	0x8996, 0 ,
	0x8997, 0 ,
	0x8998, 0 ,
	0x8999, 0 ,
	0x899A, 0 ,
	0x899B, 0 ,
	0x899C, 0 ,
	0x899D, 197 ,
	0x899E, 33 ,
	0x899F, 0 ,
	0x89A0, 154 ,
	0x89A1, 17 ,
	0x89A2, 0 ,
	0x89A3, 90 ,
	0x89A4, 1 ,
	0x89A5, 0 ,
	0x89A6, 1 ,
	0x89A7, 237 ,
	0x89A8, 176 ,
	0x89A9, 193 ,
	0x89AA, 195 ,
	0x89AB, 18 ,
	0x89AC, 139 ,
	0x8B07, 195 ,
	0x8B08, 157 ,
	0x8B09, 137 ,
ENDPATCH

BEGINPATCH(13)
	0x8B9D, 1 ,
	0x8B9E, 196 ,
	0x8BA5, 1 ,
	0x8BA6, 196 ,
	0x8E56, 205 ,
	0x8E57, 0 ,
	0x8E58, 236 ,
	0x8F1B, 239 ,
	0x8F6D, 205 ,
	0x8F6E, 191 ,
	0x8F6F, 196 ,
ENDPATCH

BEGINPATCH(14)
	0x9692, 24 ,
	0x9694, 0 ,
	0x9695, 0 ,
ENDPATCH

BEGINPATCH(15)
	0x9AAE, 2 ,
	0x9AAF, 2 ,
	0x9AB0, 70 ,
	0x9AB1, 70 ,
	0x9AB2, 4 ,
	0x9AB3, 4 ,
	0x9AB4, 69 ,
	0x9AB5, 69 ,
	0x9ACE, 2 ,
	0x9ACF, 2 ,
	0x9AD0, 70 ,
	0x9AD1, 70 ,
	0x9AD2, 4 ,
	0x9AD3, 4 ,
	0x9AD4, 69 ,
	0x9AD5, 69 ,
ENDPATCH


BEGINPATCH(dguards)	// Diagonal guardian patch
	0x84D2, 74 ,
	0x84D3, 111 ,
	0x84D4, 104 ,
	0x84D5, 110 ,
	0x84D7, 69 ,
	0x84D8, 108 ,
	0x84D9, 108 ,
	0x84DA, 105 ,
	0x84DB, 111 ,
	0x84DD, 116 ,
	0x84DE, 46 ,
	0x84DF, 32 ,
	0x84E0, 89 ,
	0x84E1, 111 ,
	0x84E2, 117 ,
	0x84E3, 32 ,
	0x84E4, 115 ,
	0x84E5, 104 ,
	0x84E6, 111 ,
	0x84E7, 117 ,
	0x84E8, 108 ,
	0x84E9, 100 ,
	0x84EA, 32 ,
	0x84EB, 107 ,
	0x84EC, 110 ,
	0x84EE, 119 ,
	0x84EF, 32 ,
	0x84F0, 119 ,
	0x84F1, 104 ,
	0x84F2, 97 ,
	0x84F3, 116 ,
	0x84F4, 32 ,
	0x84F5, 116 ,
	0x84F6, 111 ,
	0x84F7, 32 ,
	0x84F8, 100 ,
	0x84F9, 111 ,
	0x84FA, 32 ,
	0x84FB, 98 ,
	0x84FC, 121 ,
	0x84FD, 32 ,
	0x84FE, 110 ,
	0x84FF, 111 ,
	0x8500, 119 ,
	0x8501, 33 ,
	0x8502, 32 ,
	0x8503, 83 ,
	0x8504, 117 ,
	0x8505, 103 ,
	0x8506, 103 ,
	0x8507, 101 ,
	0x8508, 115 ,
	0x8509, 116 ,
	0x850A, 105 ,
	0x850B, 111 ,
	0x850C, 110 ,
	0x850D, 115 ,
	0x850E, 32 ,
	0x850F, 116 ,
	0x8510, 111 ,
	0x8511, 32 ,
	0x8512, 101 ,
	0x8513, 108 ,
	0x8514, 108 ,
	0x8515, 105 ,
	0x8516, 111 ,
	0x8517, 116 ,
	0x8518, 116 ,
	0x8519, 64 ,
	0x851B, 101 ,
	0x851C, 97 ,
	0x851D, 99 ,
	0x851E, 104 ,
	0x851F, 105 ,
	0x8520, 110 ,
	0x8521, 103 ,
	0x8522, 46 ,
	0x8523, 112 ,
	0x8524, 104 ,
	0x8525, 121 ,
	0x8526, 115 ,
	0x8527, 105 ,
	0x8528, 99 ,
	0x8529, 115 ,
	0x852A, 46 ,
	0x852B, 111 ,
	0x852C, 120 ,
	0x852E, 97 ,
	0x852F, 99 ,
	0x8530, 46 ,
	0x8531, 117 ,
	0x8532, 107 ,
	0x8533, 32 ,
ENDPATCH



BEGINPATCH(mmap)
	0x864C, 0 ,	/* Memory map */
	0x864D, 0 ,
	0x864E, 128 ,
	0x864F, 128 ,
	0x8650, 96 ,
	0x8651, 96 ,
	0x8652, 96 ,
	0x8653, 96 ,
	0x8654, 33 ,
	0x8655, 65 ,
	0x8656, 65 ,
	0x8657, 65 ,
	0x8658, 128 ,
	0x8659, 128 ,
	0x865A, 96 ,
	0x865B, 96 ,
	0x865C, 96 ,
	0x865D, 96 ,
	0x865E, 96 ,
	0x865F, 96 ,
	0x8660, 96 ,
	0x8661, 96 ,
	0x8662, 96 ,
	0x8663, 96 ,
	0x8664, 96 ,
	0x8665, 96 ,
	0x8666, 96 ,
	0x8667, 96 ,
	0x8668, 96 ,
	0x8669, 96 ,
	0x866A, 96 ,
	0x866B, 96 ,
	0x866C, 96 ,
	0x866D, 96 ,
	0x866E, 96 ,
	0x866F, 96 ,
	0x8670, 96 ,
	0x8671, 96 ,
	0x8672, 96 ,
	0x8673, 96 ,
	0x8674, 128 ,
	0x8675, 128 ,
	0x8676, 128 ,
	0x8677, 128 ,
	0x8678, 128 ,
	0x8679, 0 ,
	0x867A, 0 ,
	0x867B, 0 ,
	0x867C, 0 ,
	0x867D, 0 ,
	0x867E, 0 ,
	0x867F, 0 ,
	0x8680, 0 ,
	0x8681, 0 ,
	0x8682, 0 ,
	0x8683, 0 ,
	0x8684, 0 ,
	0x8685, 0 ,
	0x8686, 0 ,
	0x8687, 0 ,
	0x8688, 0 ,
	0x8689, 0 ,
	0x868A, 0 ,
	0x868B, 0 ,
	0x868C, 0 ,
	0x868D, 0 ,
	0x868E, 0 ,
	0x868F, 0 ,
	0x8690, 0 ,
	0x8691, 0 ,
	0x8692, 0 ,
	0x8693, 0 ,
	0x8694, 0 ,
	0x8695, 0 ,
	0x8696, 0 ,
	0x8697, 0 ,
	0x8698, 0 ,
	0x8699, 0 ,
	0x869A, 0 ,
	0x869B, 0 ,
	0x869C, 0 ,
	0x869D, 0 ,
	0x869E, 0 ,
ENDPATCH

BEGINPATCH(hl8)
	0x8F9E, 0xCD,
	0x8F9F, 0x27,
	0x8FA0, 0x86,	// CALL 8627h
	
	0x8627, 0x32,
	0x8628, 0xD1,
	0x8629, 0x85,	// LD (85D1h),A
	0x862A, 0x3A,
	0x862B, 0xCF,
	0x862C, 0x85,	// LD A,(85CFh)
	0x862D, 0xC3,
	0x862E, 0x95,
	0x862F, 0x89,	// JP 8995h

	0x8995, 0xE6,
	0x8996, 0xF8,	// AND 0F8h
	0x8997, 0x32,
	0x8998, 0xCF,
	0x8999, 0x85,	// LD (85CFh),A
	0x899A, 0xC9,	// RET
ENDPATCH



jswByte patch_84d2[0x7A] =
{
        0xB6, 0x91, 0xF5, 0x84, 0xFE, 0x84, 0xD9, 0x90,
        0xB6, 0x91, 0x07, 0x85, 0x15, 0x85, 0xFB, 0x84,
        0xB6, 0x91, 0xF2, 0x84, 0xFE, 0x84, 0xB6, 0x91,
        0xB6, 0x91, 0x04, 0x85, 0x12, 0x85, 0xFB, 0x84,

        0xCD, 0x36, 0x85,
        0xCD, 0x33, 0x91,
        0xC3, 0xB6, 0x91,
        0xCD, 0x36, 0x85,
        0xCD, 0x7F, 0x91,
        0xC3, 0xB6, 0x91,
        0xCD, 0x36, 0x85,
        0xCD, 0x33, 0x91,
        0xDD, 0xCB, 0x00, 0x7E,
        0x20, 0x1A,
        0x18, 0x0C,
        0xCD, 0x36, 0x85,
        0xCD, 0x33, 0x91,
        0xDD, 0xCB, 0x00, 0x7E,
        0x28, 0x0C,
        0xDD, 0x7E, 0x03,
        0xDD, 0x86, 0x04,
        0xDD, 0x77, 0x03,
        0xC3, 0xB6, 0x91,
        0xDD, 0x7E, 0x03,
        0xDD, 0x96, 0x04,
        0xDD, 0x77, 0x03,
        0xC3, 0xB6, 0x91,
        0xDD, 0x7E, 0x01,
        0x4F,
        0xE6, 0xF8,
        0x47, 0x79,
        0xE6, 0x07,
        0x3C,
        0xFE, 0x07,
        0x38, 0x02,
        0x3E, 0x02,
        0xB0,
        0xDD, 0x77, 0x01,
        0xC9
};

jswByte patch_90ca[15] =
{
        0xE6, 0x0F, 0x6F, 0x26, 0x00, 0x29, 0x11, 0xD2,
        0x84, 0x19, 0x5E, 0x23, 0x56, 0xEB, 0xE9
};

jswByte patch_9133[131] = 
{
        0xDD, 0xCB, 0x00, 0x7E, 0x20, 0x1F, 0xDD, 0x7E,
        0x00, 0xD6, 0x20, 0xE6, 0x7F, 0xDD, 0x77, 0x00,
        0xFE, 0x60, 0xD8, 0xDD, 0x7E, 0x02, 0xE6, 0x1F,
        0xDD, 0xBE, 0x06, 0x28, 0x04, 0xDD, 0x35, 0x02,
        0xC9, 0x06, 0x80, 0x18, 0x1D, 0xDD, 0x7E, 0x00,
        0xC6, 0x20, 0xF6, 0x80, 0xDD, 0x77, 0x00, 0xFE,
        0xA0, 0xD0, 0xDD, 0x7E, 0x02, 0xE6, 0x1F, 0xDD,
        0xBE, 0x07, 0x28, 0x04, 0xDD, 0x34, 0x02, 0xC9,
        0x06, 0x60, 0xDD, 0x7E, 0x00, 0xE6, 0x1F, 0xB0,
        0xDD, 0x77, 0x00, 0xC9, 0xDD, 0x7E, 0x00, 0xEE,
        0x08, 0xDD, 0x77, 0x00, 0xE6, 0x18, 0x28, 0x08,
        0xDD, 0x7E, 0x00, 0xC6, 0x20, 0xDD, 0x77, 0x00,
        0xDD, 0x7E, 0x03, 0xDD, 0x86, 0x04, 0xDD, 0x77,
        0x03, 0xDD, 0xBE, 0x07, 0x30, 0x0C, 0xDD, 0xBE,
        0x06, 0x28, 0x01, 0xD0, 0xDD, 0x7E, 0x06, 0xDD,
        0x77, 0x03, 0xDD, 0x7E, 0x04, 0xED, 0x44, 0xDD,
        0x77, 0x04, 0xC9
};


// Fixed blocks of data for JSW128

jswByte jsw_bank_0[] = 
{
0x00, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45,
0x45, 0x3f, 0x3f, 0x3e, 0x3e, 0x3e, 0x45, 0x45,
0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45,
0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45,
0x45, 0x5a, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45,
0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45,
0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45,
0x45, 0x45, 0x45, 0x78, 0x6c, 0x51, 0x45, 0x45,
0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45,
0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45,
0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x45, 0x6b,
0x44, 0x44, 0x42, 0x43, 0x43, 0x43, 0x43, 0x43,
0x43, 0x43, 0x43, 0x43, 0x43, 0x43, 0x43, 0x5b,
0x5b, 0x5b, 0x5b, 0x5b, 0x5d, 0x62, 0x62, 0x71,
0x75, 0x5d, 0x72, 0x50, 0x58, 0x73, 0x62, 0x62,
0x62, 0x62, 0x62, 0x62, 0x62, 0x62, 0x41, 0x53,
0x72, 0x7c, 0x7b, 0x62, 0x62, 0x62, 0x62, 0x62,
0x62, 0x62, 0x62, 0x6f, 0x61, 0x62, 0x61, 0x5e,
0x74, 0x72, 0x41, 0x6e, 0x6e, 0x7d, 0x62, 0x4c,
0x62, 0x62, 0x62, 0x62, 0x62, 0x40, 0x40, 0x40,
0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40,
0x40, 0x6e, 0x62, 0x5e, 0x6f, 0x32, 0x32, 0x32,
0x32, 0x38, 0x38, 0x38, 0x38, 0x2b, 0x2b, 0x2b,
0x2b, 0x1f, 0x12, 0x0f, 0x10, 0x11, 0x3c, 0x3b,
0x3a, 0x25, 0x25, 0x25, 0x1b, 0x39, 0x3a, 0x0b,
0x22, 0x19, 0x19, 0x19, 0x19, 0x33, 0x16, 0x16,
0x28, 0x0c, 0x0c, 0x0c, 0x09, 0x07, 0x2e, 0x2e,
0x26, 0x15, 0x15, 0x15, 0x15, 0x15, 0x0e, 0x0a,
0x15, 0x15, 0x0e, 0x0d, 0x0d, 0x2c, 0x13, 0x03,
0x03, 0x03, 0x31, 0x31, 0x31, 0x31, 0x31, 0x31,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x02, 0x1d, 0x1e, 0x21,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x08, 0x08, 0x08, 0x08, 0x08, 0x00, 0x08, 0x00,
0x24, 0x24, 0x24, 0x00, 0x00, 0x00, 0x00, 0x00,
0x24, 0x24, 0x7e, 0x24, 0x7e, 0x24, 0x24, 0x00,
0x08, 0x1e, 0x28, 0x1c, 0x0a, 0x3c, 0x08, 0x00,
0x00, 0x42, 0x44, 0x08, 0x10, 0x22, 0x42, 0x00,
0x18, 0x24, 0x18, 0x32, 0x4c, 0x44, 0x32, 0x00,
0x08, 0x08, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00,
0x04, 0x08, 0x10, 0x10, 0x10, 0x08, 0x04, 0x00,
0x10, 0x08, 0x04, 0x04, 0x04, 0x08, 0x10, 0x00,
0x00, 0x22, 0x1c, 0xff, 0x1c, 0x22, 0x00, 0x00,
0x00, 0x08, 0x08, 0x3e, 0x08, 0x08, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08, 0x10,
0x00, 0x00, 0x00, 0x3e, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x08, 0x08, 0x00,
0x02, 0x04, 0x08, 0x10, 0x20, 0x40, 0x00, 0x00,
0x3c, 0x42, 0x46, 0x5a, 0x62, 0x42, 0x3c, 0x00,
0x08, 0x38, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00,
0x3c, 0x42, 0x02, 0x0c, 0x30, 0x40, 0x7e, 0x00,
0x3c, 0x42, 0x02, 0x0c, 0x02, 0x42, 0x3c, 0x00,
0x0c, 0x1c, 0x24, 0x44, 0x7e, 0x04, 0x04, 0x00,
0x7e, 0x40, 0x40, 0x7c, 0x02, 0x42, 0x3c, 0x00,
0x3c, 0x42, 0x40, 0x7c, 0x42, 0x42, 0x3c, 0x00,
0x7e, 0x02, 0x04, 0x08, 0x10, 0x10, 0x10, 0x00,
0x3c, 0x42, 0x42, 0x3c, 0x42, 0x42, 0x3c, 0x00,
0x3c, 0x42, 0x42, 0x3e, 0x02, 0x42, 0x3c, 0x00,
0x00, 0x00, 0x08, 0x08, 0x00, 0x08, 0x08, 0x00,
0x00, 0x00, 0x08, 0x08, 0x00, 0x08, 0x08, 0x10,
0x04, 0x08, 0x10, 0x20, 0x10, 0x08, 0x04, 0x00,
0x00, 0x00, 0x3e, 0x00, 0x3e, 0x00, 0x00, 0x00,
0x20, 0x10, 0x08, 0x04, 0x08, 0x10, 0x20, 0x00,
0x3c, 0x42, 0x42, 0x04, 0x08, 0x00, 0x08, 0x00,
0x3c, 0x42, 0x4e, 0x4e, 0x4e, 0x40, 0x3c, 0x00,
0x18, 0x24, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x00,
0x7c, 0x42, 0x42, 0x7c, 0x42, 0x42, 0x7c, 0x00,
0x1c, 0x22, 0x40, 0x40, 0x40, 0x22, 0x1c, 0x00,
0x78, 0x44, 0x42, 0x42, 0x42, 0x44, 0x78, 0x00,
0x7e, 0x40, 0x40, 0x78, 0x40, 0x40, 0x7e, 0x00,
0x7e, 0x40, 0x40, 0x78, 0x40, 0x40, 0x40, 0x00,
0x1c, 0x22, 0x40, 0x40, 0x46, 0x22, 0x1e, 0x00,
0x42, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x00,
0x3e, 0x08, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00,
0x0e, 0x04, 0x04, 0x04, 0x44, 0x44, 0x38, 0x00,
0x42, 0x44, 0x48, 0x70, 0x48, 0x44, 0x42, 0x00,
0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x7e, 0x00,
0x42, 0x66, 0x7e, 0x42, 0x42, 0x42, 0x42, 0x00,
0x42, 0x62, 0x72, 0x4e, 0x46, 0x42, 0x42, 0x00,
0x3c, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00,
0x7c, 0x42, 0x42, 0x7c, 0x40, 0x40, 0x40, 0x00,
0x3c, 0x42, 0x42, 0x42, 0x48, 0x44, 0x32, 0x00,
0x7c, 0x42, 0x42, 0x7c, 0x48, 0x44, 0x42, 0x00,
0x3c, 0x42, 0x40, 0x3c, 0x02, 0x42, 0x3c, 0x00,
0x7c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x00,
0x42, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00,
0x42, 0x42, 0x42, 0x42, 0x42, 0x24, 0x18, 0x00,
0x42, 0x42, 0x42, 0x42, 0x7e, 0x66, 0x42, 0x00,
0x42, 0x24, 0x18, 0x18, 0x24, 0x42, 0x42, 0x00,
0x22, 0x22, 0x22, 0x1c, 0x08, 0x08, 0x08, 0x00,
0x7e, 0x02, 0x04, 0x08, 0x10, 0x20, 0x7e, 0x00,
0x1c, 0x10, 0x10, 0x10, 0x10, 0x10, 0x1c, 0x00,
0x40, 0x20, 0x10, 0x08, 0x04, 0x02, 0x00, 0x00,
0x1c, 0x04, 0x04, 0x04, 0x04, 0x04, 0x1c, 0x00,
0x08, 0x1c, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff,
0x1c, 0x22, 0x20, 0x78, 0x20, 0x22, 0x7e, 0x00,
0x00, 0x00, 0x3c, 0x02, 0x3e, 0x42, 0x3e, 0x00,
0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x7c, 0x00,
0x00, 0x00, 0x3c, 0x42, 0x40, 0x42, 0x3c, 0x00,
0x02, 0x02, 0x3e, 0x42, 0x42, 0x42, 0x3e, 0x00,
0x00, 0x00, 0x3c, 0x42, 0x7e, 0x40, 0x3c, 0x00,
0x1c, 0x22, 0x20, 0x7c, 0x20, 0x20, 0x20, 0x00,
0x00, 0x00, 0x3e, 0x42, 0x42, 0x3e, 0x02, 0x3c,
0x40, 0x40, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x00,
0x08, 0x00, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00,
0x02, 0x00, 0x02, 0x02, 0x02, 0x42, 0x42, 0x3c,
0x40, 0x40, 0x42, 0x44, 0x78, 0x44, 0x42, 0x00,
0x10, 0x10, 0x10, 0x10, 0x10, 0x10, 0x0c, 0x00,
0x00, 0x00, 0xec, 0x92, 0x92, 0x92, 0x92, 0x00,
0x00, 0x00, 0x7c, 0x42, 0x42, 0x42, 0x42, 0x00,
0x00, 0x00, 0x3c, 0x42, 0x42, 0x42, 0x3c, 0x00,
0x00, 0x00, 0x7c, 0x42, 0x42, 0x7c, 0x40, 0x40,
0x00, 0x00, 0x3e, 0x42, 0x42, 0x3e, 0x02, 0x02,
0x00, 0x00, 0x4e, 0x70, 0x40, 0x40, 0x40, 0x00,
0x00, 0x00, 0x3c, 0x40, 0x3c, 0x02, 0x3c, 0x00,
0x20, 0x20, 0x7c, 0x20, 0x20, 0x22, 0x1c, 0x00,
0x00, 0x00, 0x42, 0x42, 0x42, 0x42, 0x3e, 0x00,
0x00, 0x00, 0x42, 0x42, 0x42, 0x24, 0x18, 0x00,
0x00, 0x00, 0x42, 0x42, 0x42, 0x7e, 0x24, 0x00,
0x00, 0x00, 0x42, 0x24, 0x18, 0x24, 0x42, 0x00,
0x00, 0x00, 0x42, 0x42, 0x42, 0x3e, 0x02, 0x7c,
0x00, 0x00, 0x3e, 0x04, 0x08, 0x10, 0x3e, 0x00,
0x06, 0x08, 0x08, 0x30, 0x08, 0x08, 0x06, 0x00,
0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x08, 0x00,
0x30, 0x08, 0x08, 0x06, 0x08, 0x08, 0x30, 0x00,
0x32, 0x4c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x3c, 0x42, 0x99, 0xa1, 0xa1, 0x99, 0x42, 0x3c,
0x00, 0x3a, 0x00, 0xc4, 0xfe, 0x09, 0xca, 0xad,
0x89, 0x3a, 0x20, 0x84, 0xfe, 0x2e, 0xc2, 0xad,
0x89, 0x3a, 0xcf, 0x85, 0xfe, 0xd0, 0xc2, 0xad,
0x89, 0x3a, 0x00, 0xc4, 0x5f, 0x87, 0x83, 0x5f,
0x16, 0x00, 0xdd, 0x21, 0x80, 0xc4, 0xdd, 0x19,
0x01, 0xfe, 0xfb, 0xed, 0x78, 0xe6, 0x1f, 0xdd,
0xbe, 0x00, 0x28, 0x12, 0xfe, 0x1f, 0xca, 0xad,
0x89, 0xdd, 0xbe, 0xfd, 0xca, 0xad, 0x89, 0xaf,
0x32, 0x00, 0xc4, 0xc3, 0xad, 0x89, 0x06, 0xdf,
0xed, 0x78, 0xe6, 0x1f, 0xdd, 0xbe, 0x01, 0x28,
0x0d, 0xfe, 0x1f, 0xca, 0xad, 0x89, 0xdd, 0xbe,
0xfe, 0xca, 0xad, 0x89, 0x18, 0xe1, 0x06, 0xfd,
0xed, 0x78, 0xe6, 0x1f, 0xdd, 0xbe, 0x02, 0x20,
0x0a, 0x3a, 0x00, 0xc4, 0x3c, 0x32, 0x00, 0xc4,
0xc3, 0x9b, 0xc4, 0xfe, 0x1f, 0xca, 0xad, 0x89,
0xdd, 0xbe, 0xff, 0xca, 0xad, 0x89, 0x18, 0xbf,
0x1f, 0x1f, 0x1d, 0x1f, 0x17, 0x1f, 0x1f, 0x1e,
0x1f, 0x1b, 0x1f, 0x1f, 0x17, 0x1f, 0x1f, 0x1f,
0x17, 0x1f, 0x1f, 0x1f, 0x1d, 0x1b, 0x1f, 0x1f,
0x17, 0x1f, 0x1f, 0xfe, 0x09, 0xc2, 0xad, 0x89,
0x01, 0xff, 0x80, 0xaf, 0xd3, 0xfe, 0x3c, 0xe6,
0x07, 0x0d, 0x20, 0xf8, 0x10, 0xfa, 0x3a, 0xde,
0x80, 0xd3, 0xfe, 0xc3, 0xad, 0x89, 0x29, 0x29,
0x29, 0xed, 0x4b, 0xdf, 0x80, 0x09, 0xc9, 0x3a,
0x00, 0xc4, 0xfe, 0x09, 0x20, 0x36, 0x01, 0xfe,
0xfe, 0xed, 0x78, 0x2f, 0xe6, 0x1f, 0x28, 0x28,
0xcb, 0x67, 0x20, 0x1f, 0xcb, 0x5f, 0x20, 0x16,
0xcb, 0x57, 0x20, 0x0d, 0xcb, 0x4f, 0x28, 0x18,
0x3a, 0xe9, 0x80, 0x32, 0x20, 0x84, 0xc3, 0xc0,
0x87, 0x3a, 0xec, 0x80, 0x18, 0xf5, 0x3a, 0xeb,
0x80, 0x18, 0xf0, 0x3a, 0xea, 0x80, 0x18, 0xeb,
0x01, 0xfe, 0x7f, 0xc9, 0x01, 0xfe, 0x7e, 0xc9,
0x02, 0x2f, 0x00, 0x40, 0x04, 0xb0, 0x40, 0x90,
0x03, 0x22, 0x0f, 0x00, 0x20, 0x00, 0x83, 0x36,
0x02, 0x2e, 0x14, 0x48, 0x04, 0xb0, 0x40, 0x90,
0x02, 0x2d, 0x12, 0x50, 0x04, 0xb0, 0x40, 0x90,
0x12, 0x26, 0xd6, 0x60, 0x08, 0xbf, 0x60, 0xc0,
0x02, 0x2c, 0x99, 0x58, 0x04, 0xb0, 0x40, 0x90,
0x02, 0x27, 0xcf, 0xd0, 0x00, 0xc9, 0xd0, 0xd0,
0x02, 0x2b, 0x0e, 0x60, 0x04, 0xb0, 0x40, 0x90,
0x02, 0x0f, 0xb3, 0x28, 0x04, 0xa8, 0x00, 0x90,
0xa1, 0x6e, 0x8a, 0xa0, 0x04, 0xbb, 0x0a, 0x14,
0x12, 0x6d, 0x94, 0x60, 0x08, 0xbe, 0x10, 0xd0,
0x12, 0x66, 0x0d, 0xc0, 0xf6, 0xbf, 0x70, 0xc0,
0x01, 0x64, 0x1d, 0x70, 0x01, 0xbe, 0x13, 0x1d,
0x02, 0x2c, 0x4f, 0x70, 0x00, 0xc9, 0x70, 0x70,
0x12, 0x6b, 0x87, 0x40, 0x10, 0xb9, 0x00, 0xd0,
0x12, 0x27, 0x94, 0x10, 0x04, 0xb0, 0x00, 0x20,
0x02, 0x04, 0x95, 0x60, 0x02, 0xba, 0x00, 0xb0,
0x02, 0x04, 0xb7, 0x60, 0x02, 0xba, 0x00, 0xb0,
0x12, 0x24, 0xc5, 0x80, 0x02, 0xba, 0x20, 0xd0,
0x12, 0x2e, 0xd8, 0x80, 0x08, 0xa8, 0x00, 0xa0,
0x01, 0xea, 0x09, 0xa0, 0x00, 0xbc, 0x00, 0x0a,
0x02, 0x00, 0x18, 0x80, 0x10, 0xa8, 0x00, 0xd0,
0x02, 0x2c, 0x1b, 0xd0, 0x00, 0xc9, 0xd0, 0xd0,
0xa1, 0xe6, 0x04, 0x30, 0x00, 0xbc, 0x01, 0x13,
0x01, 0xed, 0x07, 0x50, 0x00, 0xbc, 0x00, 0x0a,
0x01, 0xeb, 0x13, 0x70, 0x00, 0xbc, 0x0e, 0x17,
0x01, 0xea, 0x18, 0x30, 0x00, 0xb6, 0x05, 0x1e,
0x12, 0x6a, 0x15, 0x90, 0xfc, 0xb2, 0x80, 0xd0,
0x02, 0x2a, 0x14, 0x68, 0x04, 0xb0, 0x40, 0x90,
0x02, 0x29, 0x0a, 0x70, 0x04, 0xb0, 0x40, 0x90,
0x12, 0xe5, 0x90, 0x40, 0xfc, 0xad, 0x00, 0x80,
0xa1, 0xeb, 0x59, 0x70, 0x04, 0xbc, 0x00, 0x1a,
0xa1, 0xe5, 0x04, 0xd0, 0x01, 0xcb, 0x00, 0x07,
0x21, 0x63, 0x1a, 0xd0, 0x00, 0xcc, 0x15, 0x1e,
0xa1, 0x2d, 0xc5, 0xd0, 0x01, 0xa8, 0x00, 0x0b,
0xa1, 0x6b, 0x13, 0xd0, 0x00, 0xae, 0x00, 0x0d,
0x81, 0x65, 0x96, 0xd0, 0x00, 0xca, 0x0a, 0x1e,
0x01, 0xea, 0x16, 0xa0, 0x00, 0xbc, 0x08, 0x18,
0x01, 0x6e, 0x04, 0x60, 0x00, 0xae, 0x02, 0x07,
0x01, 0x65, 0x10, 0x80, 0x00, 0xca, 0x0c, 0x12,
0xa1, 0x66, 0x18, 0x60, 0x04, 0xcc, 0x0f, 0x1e,
0xa1, 0xed, 0x0d, 0x40, 0x02, 0xb5, 0x07, 0x18,
0x12, 0x4b, 0x07, 0x90, 0xfa, 0xba, 0x60, 0xae,
0x02, 0x0a, 0x4f, 0x00, 0x04, 0x9c, 0x00, 0x60,
0x12, 0x4a, 0x2c, 0x40, 0x04, 0xba, 0x00, 0xd0,
0x12, 0x45, 0x46, 0xb0, 0x08, 0xba, 0x00, 0xd0,
0x01, 0x66, 0x88, 0xa0, 0x00, 0xbb, 0x00, 0x13,
0x02, 0x0b, 0x93, 0x00, 0x02, 0x9c, 0x00, 0x80,
0x02, 0x0c, 0x57, 0x00, 0x04, 0x9c, 0x00, 0xa0,
0xa1, 0x0a, 0x6c, 0x10, 0x04, 0x9c, 0x0c, 0x1e,
0x02, 0x66, 0x1c, 0x20, 0x00, 0xa9, 0x20, 0x20,
0x21, 0x0e, 0xd6, 0xd0, 0x02, 0xcc, 0x00, 0x16,
0x21, 0x6c, 0x93, 0xd0, 0x00, 0xa7, 0x07, 0x1e,
0x01, 0xeb, 0x08, 0xd0, 0x00, 0xb5, 0x04, 0x0e,
0xa1, 0x60, 0x86, 0x30, 0x00, 0xa9, 0x03, 0x10,
0xa1, 0x0c, 0x6e, 0x90, 0x00, 0x9c, 0x06, 0x18,
0x21, 0x09, 0xd8, 0x50, 0x00, 0xcc, 0x07, 0x18,
0x02, 0x2f, 0x82, 0x00, 0x02, 0xb0, 0x00, 0x10,
0x02, 0x64, 0x84, 0x10, 0x00, 0xb2, 0x10, 0x10,
0xa1, 0x6a, 0x0a, 0xd0, 0x00, 0xae, 0x00, 0x15,
0x84, 0x06, 0x54, 0x00, 0xd0, 0x00, 0x82, 0x00,
0x02, 0x62, 0x95, 0x80, 0x04, 0xb2, 0x40, 0xb0,
0x12, 0x62, 0x8d, 0x60, 0x04, 0xb2, 0x50, 0xb0,
0x02, 0x2e, 0xd9, 0x10, 0x00, 0xb0, 0x10, 0x10,
0x21, 0x6b, 0x9a, 0xd0, 0x00, 0xcc, 0x05, 0x1e,
0x21, 0x6f, 0x13, 0xb0, 0x00, 0xca, 0x07, 0x1e,
0xa1, 0x6f, 0x13, 0xd0, 0x00, 0xca, 0x0a, 0x1e,
0x21, 0xe6, 0x8c, 0x30, 0x00, 0xd1, 0x01, 0x0c,
0xa1, 0xe0, 0x84, 0x70, 0x00, 0xd1, 0x04, 0x0c,
0x04, 0x06, 0x64, 0x00, 0x1c, 0x00, 0x41, 0x00,
0x02, 0x67, 0x1a, 0x50, 0x04, 0xa8, 0x00, 0xb0,
0x02, 0x07, 0x9a, 0x70, 0x04, 0xa8, 0x20, 0xd0,
0x02, 0x65, 0x77, 0x00, 0x08, 0xb3, 0x00, 0xd0,
0x02, 0x07, 0x6a, 0x00, 0x02, 0xa7, 0x00, 0xb0,
0xa1, 0x6b, 0x01, 0x40, 0x00, 0xad, 0x01, 0x18,
0x21, 0x64, 0x90, 0x90, 0x00, 0xca, 0x00, 0x1b,
0x02, 0x6a, 0x1d, 0x40, 0x02, 0xab, 0x40, 0x50,
0xa1, 0x62, 0x16, 0x40, 0x00, 0xb9, 0x07, 0x1c,
0x02, 0x2d, 0x05, 0x80, 0xf8, 0xa7, 0x00, 0xa0,
0x41, 0xe9, 0x0b, 0xd0, 0x00, 0xb4, 0x0b, 0x12,
0xa1, 0xed, 0x05, 0xd0, 0x00, 0xaa, 0x00, 0x0d,
0x12, 0x2b, 0x09, 0x60, 0x08, 0xa7, 0x00, 0x70,
0x21, 0x65, 0x16, 0x80, 0x04, 0xbb, 0x0a, 0x19,
0xa1, 0xe1, 0x02, 0xb0, 0x04, 0xbc, 0x00, 0x11,
0x02, 0x25, 0x81, 0x80, 0x04, 0xbf, 0x70, 0xb0,
0x21, 0x66, 0x0f, 0xd0, 0x04, 0xae, 0x00, 0x1e,
0xa1, 0x6b, 0x84, 0xd0, 0x04, 0xa9, 0x04, 0x17,
0xa1, 0x6b, 0x84, 0xd0, 0x04, 0xa7, 0x00, 0x1b,
0x01, 0xe6, 0x14, 0xa0, 0x00, 0xb5, 0x13, 0x1e,
0xa1, 0x66, 0x97, 0xd0, 0x00, 0xa9, 0x15, 0x1e,
0x81, 0x63, 0x01, 0x30, 0x00, 0xae, 0x00, 0x0b,
0x12, 0x2e, 0xdc, 0x60, 0x00, 0xb0, 0x60, 0x60,
0x02, 0x2e, 0xc6, 0x90, 0x00, 0xb0, 0x90, 0x90,
0xa1, 0xee, 0x04, 0xd0, 0x00, 0xcb, 0x12, 0x1e,
0xa1, 0xed, 0x96, 0xd0, 0x00, 0xcb, 0x00, 0x07,
0xa1, 0xed, 0x0b, 0xd0, 0x00, 0xaa, 0x00, 0x0a,
0xa1, 0xe3, 0x19, 0xa0, 0xfc, 0xb4, 0x11, 0x1e,
0x12, 0x65, 0x8f, 0x40, 0x08, 0xac, 0x00, 0xc0,
0x02, 0x66, 0x90, 0xd0, 0x00, 0xa9, 0xd0, 0xd0,
0xa1, 0x67, 0x8f, 0xd0, 0x00, 0xb1, 0x00, 0x1e,
0xa1, 0x6f, 0x88, 0x50, 0xfe, 0xb1, 0x09, 0x19,
0x02, 0x6b, 0x07, 0x60, 0x04, 0xab, 0x50, 0xa0,
0x12, 0x65, 0x91, 0x98, 0x02, 0xab, 0x50, 0xa0,
0x01, 0x63, 0x0c, 0xc0, 0x00, 0xb4, 0x00, 0x0f,
0x01, 0xe6, 0x04, 0x20, 0x00, 0xbc, 0x00, 0x0a,
0x01, 0x66, 0x17, 0x30, 0x00, 0xbe, 0x16, 0x1e,
0x01, 0x6a, 0x14, 0xb0, 0x00, 0xae, 0x11, 0x1e,
0x81, 0x64, 0x14, 0x30, 0x00, 0xbe, 0x12, 0x16,
0x81, 0x63, 0x91, 0x90, 0x00, 0xbb, 0x0b, 0x12,
0x01, 0xe6, 0xb0, 0x70, 0x00, 0xbc, 0x09, 0x1e,
0x01, 0x63, 0x14, 0xd0, 0x00, 0xae, 0x11, 0x1e,
0x01, 0x63, 0x05, 0xb0, 0x00, 0xb5, 0x00, 0x0b,
0xa1, 0xe7, 0x19, 0xd0, 0x00, 0x9d, 0x10, 0x1e,
0x02, 0x0c, 0xb2, 0x3c, 0x04, 0xba, 0x00, 0x80,
0x02, 0x2c, 0xd1, 0x5c, 0x04, 0xba, 0x20, 0xa0,
0xa1, 0xe6, 0x02, 0x30, 0x00, 0xbd, 0x02, 0x0e,
0x12, 0x6c, 0x0c, 0x68, 0x08, 0xac, 0x00, 0xd0,
0xa1, 0x6c, 0x01, 0x70, 0x00, 0xbe, 0x01, 0x0b,
0x02, 0x02, 0x6d, 0x20, 0x08, 0x9c, 0x20, 0x80,
0xa1, 0xe5, 0x0e, 0x20, 0x00, 0xbc, 0x05, 0x16,
0x12, 0x6c, 0x0d, 0x80, 0x04, 0xac, 0x50, 0xd0,
0x02, 0x65, 0x9a, 0x90, 0x02, 0xab, 0x90, 0xd0,
0x12, 0x2f, 0x0f, 0xe0, 0xf0, 0x9c, 0x00, 0xe0,
0x02, 0x27, 0x11, 0xd8, 0xf4, 0x9c, 0x00, 0xd8,
0x04, 0x00, 0x48, 0x00, 0xff, 0x00, 0x41, 0x00,
0xa1, 0x6f, 0x08, 0x70, 0x00, 0xb1, 0x09, 0x19,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01,
0x1f, 0xf8, 0x3f, 0xfc, 0x7f, 0xfe, 0xff, 0xff,
0xe8, 0x37, 0xeb, 0xd7, 0xeb, 0xd7, 0xeb, 0xd7,
0xe0, 0x07, 0xea, 0xf7, 0xeb, 0x77, 0xeb, 0xb7,
0xeb, 0xd7, 0x7f, 0xfe, 0x3f, 0xfc, 0x1f, 0xf8,
0x1f, 0xf8, 0x20, 0x04, 0x5f, 0xfa, 0xbf, 0xfd,
0xa8, 0x35, 0xab, 0xd5, 0xab, 0xd5, 0xab, 0xd5,
0xa0, 0x05, 0xaa, 0xf5, 0xab, 0x75, 0xab, 0xb5,
0xab, 0xd5, 0x5f, 0xfa, 0x20, 0x04, 0x1f, 0xf8,
0x10, 0x08, 0x2f, 0xf4, 0x5f, 0xfa, 0xdf, 0xfb,
0xdf, 0xfb, 0xb1, 0x8d, 0xaa, 0x55, 0xb1, 0x8d,
0xde, 0xfb, 0xcd, 0xf3, 0xdd, 0xbb, 0xd6, 0x6b,
0xd9, 0x9b, 0x6c, 0x36, 0x37, 0xec, 0x18, 0x18,
0x10, 0x08, 0x2f, 0xf4, 0x5f, 0xfa, 0xdf, 0xfb,
0xdf, 0xfb, 0xb1, 0x8d, 0xaa, 0x55, 0xb1, 0x8d,
0xde, 0xfb, 0xcd, 0xf3, 0xdd, 0xbb, 0xd2, 0x4b,
0xd0, 0x0b, 0x68, 0x16, 0x34, 0x2c, 0x13, 0xc8,
0x00, 0x0f, 0x00, 0x3f, 0x00, 0x0f, 0x30, 0x0f,
0x0c, 0x0f, 0x03, 0x0f, 0x00, 0xcf, 0x00, 0x2f,
0x00, 0x08, 0x3f, 0xf8, 0x3f, 0xf0, 0x3f, 0xee,
0x1f, 0xdf, 0x1f, 0xdb, 0x0f, 0xfb, 0x0f, 0xfb,
0x00, 0x0f, 0x00, 0x3f, 0x00, 0x0f, 0x00, 0x0f,
0x00, 0x0f, 0x00, 0x0f, 0x00, 0x0f, 0x3f, 0xef,
0x00, 0x08, 0x3f, 0xf8, 0x3f, 0xf0, 0x3f, 0xee,
0x1f, 0xdf, 0x1f, 0xdb, 0x0f, 0xfb, 0x0f, 0xfb,
0x03, 0xaf, 0x01, 0xbf, 0x01, 0x8f, 0x01, 0x8f,
0x7f, 0x8f, 0x7f, 0x8f, 0x47, 0xcf, 0x0f, 0xcf,
0x00, 0x08, 0x3f, 0xf8, 0x3f, 0xf0, 0x3f, 0xee,
0x1f, 0xdf, 0x1f, 0xdb, 0x0f, 0xfb, 0x0f, 0xfb,
0x00, 0x0f, 0x04, 0x3f, 0x1e, 0x2f, 0x3b, 0x2f,
0x5d, 0x8f, 0x0e, 0x8f, 0x07, 0xcf, 0x0f, 0xcf,
0x00, 0x08, 0x3f, 0xf8, 0x3f, 0xf0, 0x3f, 0xee,
0x1f, 0xdf, 0x1f, 0xdb, 0x0f, 0xfb, 0x0f, 0xfb,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x3c, 0x00, 0x42, 0x00, 0xbf, 0x00, 0xbf, 0x00,
0xbf, 0x00, 0xbd, 0x00, 0x7a, 0x00, 0x3c, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x0f, 0x00, 0x10, 0x80, 0x2f, 0xc0,
0x2f, 0xc0, 0x2f, 0xc0, 0x2f, 0x40, 0x1e, 0x80,
0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x03, 0xc0, 0x04, 0x20,
0x0b, 0xf0, 0x0b, 0xf0, 0x0b, 0xf0, 0x0b, 0xd0,
0x07, 0xa0, 0x03, 0xc0, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x3c, 0x00, 0x42, 0x00, 0xbf,
0x00, 0xbf, 0x00, 0xbf, 0x00, 0xbd, 0x00, 0x7a,
0x00, 0x3c, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x0c, 0x00, 0x16, 0x00, 0x2f, 0x00, 0x2f, 0x00,
0x4f, 0x80, 0x5f, 0x80, 0x5f, 0x80, 0x9f, 0xc0,
0xbf, 0xc0, 0xbd, 0xc0, 0xba, 0xc0, 0xbd, 0x40,
0x5a, 0x80, 0x5d, 0x80, 0x3f, 0x00, 0x0c, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x70,
0x03, 0x98, 0x0c, 0x78, 0x33, 0xf8, 0x47, 0xf0,
0x5f, 0xf0, 0xbf, 0xf0, 0xbe, 0xa0, 0xbd, 0x60,
0x5a, 0xc0, 0x5d, 0x40, 0x3f, 0x80, 0x0e, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x03, 0xc0, 0x1c, 0x78, 0x21, 0xfc, 0x4f, 0xfe,
0x5f, 0xfe, 0x9f, 0xff, 0xbf, 0xef, 0x5f, 0x56,
0x5f, 0xae, 0x23, 0x54, 0x1f, 0xf8, 0x03, 0xc0,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0e, 0x00,
0x17, 0xc0, 0x17, 0xf0, 0x13, 0xfc, 0x0b, 0xfe,
0x0b, 0xfe, 0x0b, 0xd7, 0x05, 0xeb, 0x05, 0xd7,
0x02, 0xea, 0x02, 0x7e, 0x01, 0x8c, 0x00, 0x70,
0x00, 0x00, 0x06, 0x00, 0x08, 0x00, 0x38, 0x00,
0x50, 0x00, 0xf0, 0x00, 0xf8, 0x00, 0x3c, 0x00,
0x3e, 0x00, 0x7e, 0x00, 0x9f, 0x00, 0x1f, 0x00,
0x1f, 0xc0, 0x0e, 0xc0, 0x18, 0x00, 0x60, 0x00,
0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x14, 0x80,
0x3c, 0x00, 0x0e, 0x00, 0x3f, 0x00, 0x0f, 0x80,
0x1f, 0x80, 0x2f, 0xc0, 0x0f, 0xc0, 0x07, 0xf0,
0x03, 0xb0, 0x01, 0x00, 0x02, 0x00, 0x04, 0x00,
0x00, 0x00, 0x00, 0x60, 0x00, 0x80, 0x03, 0x80,
0x0d, 0x00, 0x07, 0x00, 0x03, 0x80, 0x07, 0xc0,
0x0b, 0xe0, 0x07, 0xe0, 0x09, 0xf0, 0x01, 0xf0,
0x01, 0xfc, 0x00, 0xec, 0x01, 0x80, 0x06, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x04, 0x00, 0x08,
0x00, 0x70, 0x00, 0xa0, 0x01, 0xe0, 0x00, 0x70,
0x01, 0xf8, 0x00, 0x78, 0x01, 0xfc, 0x00, 0x7c,
0x00, 0x7c, 0x00, 0x7f, 0x00, 0x3b, 0x00, 0xf0,
0x00, 0x00, 0x00, 0x00, 0x20, 0x00, 0x10, 0x00,
0x0e, 0x00, 0x05, 0x00, 0x07, 0x80, 0x0e, 0x00,
0x1f, 0x80, 0x1e, 0x00, 0x3f, 0x80, 0x3e, 0x00,
0x3e, 0x00, 0xfe, 0x00, 0xdc, 0x00, 0x0f, 0x00,
0x00, 0x00, 0x06, 0x00, 0x01, 0x00, 0x01, 0xc0,
0x00, 0xb0, 0x00, 0xe0, 0x01, 0xc0, 0x03, 0xe0,
0x07, 0xd0, 0x07, 0xe0, 0x0f, 0x90, 0x0f, 0x80,
0x3f, 0x80, 0x37, 0x00, 0x01, 0x80, 0x00, 0x60,
0x00, 0x00, 0x00, 0x00, 0x00, 0xf0, 0x01, 0x28,
0x00, 0x3c, 0x00, 0x70, 0x00, 0xfc, 0x01, 0xf0,
0x01, 0xf8, 0x03, 0xf4, 0x03, 0xf0, 0x0f, 0xe0,
0x0d, 0xc0, 0x00, 0x80, 0x00, 0x40, 0x00, 0x20,
0x00, 0x00, 0x00, 0x60, 0x00, 0x10, 0x00, 0x1c,
0x00, 0x0a, 0x00, 0x0f, 0x00, 0x1f, 0x00, 0x3c,
0x00, 0x7c, 0x00, 0x7e, 0x00, 0xf9, 0x00, 0xf8,
0x03, 0xf8, 0x03, 0x70, 0x00, 0x18, 0x00, 0x06,
0x00, 0x0f, 0x78, 0x0c, 0x78, 0x08, 0x30, 0x08,
0x31, 0x88, 0x33, 0xc8, 0x7f, 0xf8, 0xca, 0x98,
0xba, 0xa8, 0xa8, 0x98, 0xc8, 0xa8, 0x7f, 0xf8,
0x98, 0xcc, 0xbf, 0xa7, 0x25, 0x2a, 0x18, 0xc4,
0x78, 0x00, 0x78, 0x0f, 0x30, 0x0c, 0x31, 0x88,
0x33, 0xc8, 0x33, 0xc8, 0x7f, 0xf8, 0xca, 0x98,
0xba, 0xa8, 0xa8, 0x98, 0xc8, 0xa8, 0x7f, 0xf8,
0x98, 0xcc, 0xaf, 0xe7, 0x25, 0x2a, 0x18, 0xc4,
0x00, 0x0f, 0x78, 0x0c, 0x78, 0x08, 0x31, 0x88,
0x33, 0xc8, 0x33, 0xc8, 0x7f, 0xf8, 0xca, 0x98,
0xba, 0xa8, 0xa8, 0x98, 0xc8, 0xa8, 0x7f, 0xf8,
0x98, 0xcc, 0xa5, 0x27, 0x2f, 0xea, 0x18, 0xc4,
0x78, 0x00, 0x78, 0x0f, 0x30, 0x0c, 0x30, 0x08,
0x31, 0x88, 0x33, 0xc8, 0x7f, 0xf8, 0xca, 0x98,
0xba, 0xa8, 0xa8, 0x98, 0xc8, 0xa8, 0x7f, 0xf8,
0x98, 0xcc, 0xa5, 0x27, 0x3f, 0xaa, 0x18, 0xc4,
0x76, 0x00, 0x00, 0x00, 0x6e, 0x00, 0x76, 0x00,
0x6e, 0x00, 0x00, 0x00, 0x76, 0x00, 0x6e, 0x00,
0x00, 0x00, 0x76, 0x00, 0x00, 0x00, 0x00, 0x00,
0x6e, 0x00, 0x76, 0x00, 0x00, 0x00, 0x6e, 0x00,
0x1d, 0x80, 0x2a, 0x00, 0x27, 0x60, 0x51, 0xb0,
0x4b, 0xd0, 0x90, 0x80, 0xaa, 0xe8, 0x94, 0xb8,
0x91, 0x80, 0xaa, 0xd8, 0x91, 0x00, 0x55, 0x00,
0x4b, 0xb0, 0x2b, 0x60, 0x24, 0x00, 0x1d, 0x80,
0x03, 0xc0, 0x0c, 0x30, 0x10, 0x98, 0x32, 0x14,
0x68, 0x82, 0x40, 0x2a, 0xb5, 0x11, 0xc8, 0x45,
0xa4, 0x91, 0x9a, 0x05, 0x48, 0x42, 0x55, 0x0a,
0x28, 0x54, 0x12, 0x88, 0x0d, 0x70, 0x03, 0xc0,
0x01, 0xb8, 0x00, 0x54, 0x06, 0xe4, 0x0d, 0x8a,
0x0b, 0xd2, 0x01, 0x09, 0x17, 0x55, 0x1d, 0x29,
0x01, 0x89, 0x1b, 0x55, 0x00, 0x89, 0x00, 0xaa,
0x0d, 0xd2, 0x06, 0xd4, 0x00, 0x24, 0x01, 0xb8,
0xbe, 0x00, 0xe7, 0x00, 0xe6, 0x00, 0xbc, 0x00,
0x3e, 0x00, 0xfe, 0x00, 0x3f, 0xc0, 0x1e, 0x00,
0x3e, 0x00, 0xfe, 0x00, 0x1c, 0x00, 0x1c, 0x00,
0x36, 0x00, 0x36, 0x00, 0xe3, 0x80, 0x36, 0x00,
0x4f, 0x80, 0x79, 0xc0, 0x79, 0x80, 0x4f, 0x00,
0x0f, 0x90, 0x1f, 0xa0, 0x3f, 0xf0, 0x07, 0xa0,
0x3f, 0x90, 0x1f, 0x80, 0x07, 0x00, 0x07, 0x00,
0x07, 0x00, 0x07, 0x00, 0x07, 0x00, 0x0f, 0x80,
0x23, 0xe0, 0x3e, 0x70, 0x3e, 0x60, 0x23, 0xc4,
0x03, 0xe8, 0x07, 0xe8, 0x0f, 0xfc, 0x0f, 0xe8,
0x0f, 0xe8, 0x07, 0xe4, 0x01, 0xc0, 0x01, 0xc0,
0x03, 0x60, 0x03, 0x60, 0x0e, 0x38, 0x03, 0x60,
0x04, 0xf8, 0x07, 0x9c, 0x07, 0x98, 0x04, 0xf0,
0x00, 0xf9, 0x01, 0xfa, 0x03, 0xff, 0x00, 0x7a,
0x03, 0xf9, 0x01, 0xf8, 0x00, 0x70, 0x00, 0xf8,
0x05, 0xdd, 0x03, 0x8e, 0x01, 0x04, 0x00, 0x88,
0x1f, 0x20, 0x39, 0xe0, 0x19, 0xe0, 0x0f, 0x20,
0x9f, 0x00, 0x5f, 0x80, 0xff, 0xc0, 0x5e, 0x00,
0x9f, 0xc0, 0x1f, 0x80, 0x0e, 0x00, 0x1f, 0x00,
0xbb, 0xa0, 0x71, 0xc0, 0x20, 0x80, 0x11, 0x00,
0x07, 0xc4, 0x0e, 0x7c, 0x06, 0x7c, 0x23, 0xc4,
0x17, 0xc0, 0x17, 0xe0, 0x3f, 0xf0, 0x17, 0xf0,
0x17, 0xf0, 0x27, 0xe0, 0x03, 0x80, 0x03, 0x80,
0x06, 0xc0, 0x06, 0xc0, 0x1c, 0x70, 0x06, 0xc0,
0x01, 0xf2, 0x03, 0x9e, 0x01, 0x9e, 0x00, 0xf2,
0x09, 0xf0, 0x05, 0xf8, 0x0f, 0xfc, 0x05, 0xe0,
0x09, 0xfc, 0x01, 0xf8, 0x00, 0xe0, 0x00, 0xe0,
0x00, 0xe0, 0x00, 0xe0, 0x00, 0xe0, 0x01, 0xf0,
0x00, 0x7d, 0x00, 0xe7, 0x00, 0x67, 0x00, 0x3d,
0x00, 0x7c, 0x00, 0x7f, 0x03, 0xfc, 0x00, 0x78,
0x00, 0x7c, 0x00, 0x7f, 0x00, 0x38, 0x00, 0x38,
0x00, 0x6c, 0x00, 0x6c, 0x01, 0xc7, 0x00, 0x6c,
0x0c, 0x00, 0x1e, 0x00, 0x1b, 0x00, 0x1e, 0xc0,
0x39, 0x00, 0x32, 0x00, 0x3a, 0x00, 0x3d, 0x00,
0x6d, 0x00, 0x69, 0x00, 0x69, 0x00, 0x61, 0x00,
0x71, 0x00, 0xbe, 0x00, 0x08, 0x00, 0x1e, 0x00,
0x03, 0x00, 0x07, 0x80, 0x06, 0xc0, 0x07, 0xb0,
0x0e, 0x40, 0x0c, 0x80, 0x0f, 0x80, 0x0d, 0xc0,
0x1b, 0x40, 0x1b, 0x40, 0x16, 0x40, 0x18, 0x40,
0x1c, 0x40, 0x2f, 0x80, 0x05, 0x40, 0x0f, 0x80,
0x00, 0xc0, 0x01, 0xe0, 0x01, 0xb0, 0x01, 0xec,
0x03, 0x90, 0x03, 0x20, 0x03, 0xa0, 0x03, 0xd0,
0x06, 0xd0, 0x06, 0x90, 0x06, 0x90, 0x06, 0x10,
0x07, 0x10, 0x0b, 0xe8, 0x02, 0x50, 0x07, 0xe0,
0x00, 0x30, 0x00, 0x78, 0x00, 0x6c, 0x00, 0x7b,
0x00, 0xe4, 0x00, 0xc8, 0x00, 0xe8, 0x00, 0xf4,
0x01, 0xb4, 0x01, 0x94, 0x01, 0x94, 0x01, 0x84,
0x01, 0xc4, 0x02, 0xf8, 0x00, 0x54, 0x00, 0xf8,
0x0c, 0x00, 0x1e, 0x00, 0x36, 0x00, 0xde, 0x00,
0x27, 0x00, 0x13, 0x00, 0x17, 0x00, 0x2f, 0x00,
0x2d, 0x80, 0x29, 0x80, 0x29, 0x80, 0x21, 0x80,
0x23, 0x80, 0x1f, 0x40, 0x2a, 0x00, 0x1f, 0x00,
0x03, 0x00, 0x07, 0x80, 0x0d, 0x80, 0x37, 0x80,
0x09, 0xc0, 0x04, 0xc0, 0x05, 0xc0, 0x0b, 0xc0,
0x0b, 0x60, 0x09, 0x60, 0x09, 0x60, 0x08, 0x60,
0x08, 0xe0, 0x17, 0xd0, 0x0a, 0x40, 0x07, 0xe0,
0x00, 0xc0, 0x01, 0xe0, 0x03, 0x60, 0x0d, 0xe0,
0x02, 0x70, 0x01, 0x30, 0x01, 0xf0, 0x03, 0xb0,
0x02, 0xd8, 0x02, 0xd8, 0x02, 0x68, 0x02, 0x18,
0x02, 0x38, 0x01, 0xf4, 0x02, 0xa0, 0x01, 0xf0,
0x00, 0x30, 0x00, 0x78, 0x00, 0xd8, 0x03, 0x78,
0x00, 0x9c, 0x00, 0x4c, 0x00, 0x5c, 0x00, 0xbc,
0x00, 0xb6, 0x00, 0x96, 0x00, 0x96, 0x00, 0x86,
0x00, 0x8e, 0x00, 0x7d, 0x00, 0x10, 0x00, 0x78,
0x30, 0x00, 0x58, 0x00, 0xf8, 0x00, 0x35, 0x00,
0x6a, 0x80, 0xd5, 0x00, 0xda, 0xc0, 0x61, 0xc0,
0x30, 0x80, 0x3f, 0xc0, 0x3f, 0x80, 0x1f, 0x00,
0x04, 0x00, 0x04, 0x00, 0x0a, 0x00, 0x00, 0x00,
0x0c, 0x00, 0x16, 0x00, 0x3e, 0x00, 0x0c, 0x00,
0x18, 0x00, 0x30, 0x00, 0x37, 0xd0, 0x1c, 0x70,
0x08, 0x20, 0x0d, 0x50, 0x0f, 0xe0, 0x07, 0xc0,
0x01, 0x00, 0x02, 0x80, 0x00, 0x00, 0x00, 0x00,
0x03, 0x00, 0x05, 0x80, 0x0f, 0x80, 0x03, 0x00,
0x06, 0x00, 0x0c, 0x00, 0x0d, 0xf4, 0x07, 0x1c,
0x03, 0x18, 0x03, 0x0c, 0x03, 0xa8, 0x01, 0x50,
0x00, 0xa8, 0x00, 0x40, 0x00, 0xa0, 0x00, 0x00,
0x00, 0xc0, 0x01, 0x60, 0x03, 0xe0, 0x00, 0xc0,
0x01, 0x80, 0x03, 0x00, 0x03, 0x7d, 0x01, 0xc7,
0x00, 0x82, 0x00, 0xd5, 0x00, 0xfe, 0x00, 0x7c,
0x00, 0x10, 0x00, 0x10, 0x00, 0x10, 0x00, 0x28,
0x03, 0x00, 0x06, 0x80, 0x07, 0xc0, 0x03, 0x00,
0x01, 0x80, 0x00, 0xc0, 0xbe, 0xc0, 0xe3, 0x80,
0x41, 0x00, 0xab, 0x00, 0x7f, 0x00, 0x3e, 0x00,
0x08, 0x00, 0x08, 0x00, 0x08, 0x00, 0x14, 0x00,
0x00, 0xc0, 0x01, 0xa0, 0x01, 0xf0, 0x00, 0xc0,
0x00, 0x60, 0x00, 0x30, 0x2f, 0xb0, 0x38, 0xe0,
0x18, 0xc0, 0x30, 0xc0, 0x15, 0xc0, 0x0a, 0x80,
0x15, 0x00, 0x02, 0x00, 0x05, 0x00, 0x00, 0x00,
0x00, 0x30, 0x00, 0x68, 0x00, 0x7c, 0x00, 0x30,
0x00, 0x18, 0x00, 0x0c, 0x0b, 0xec, 0x0e, 0x38,
0x04, 0x10, 0x0a, 0xb0, 0x07, 0xf0, 0x03, 0xe0,
0x00, 0x80, 0x01, 0x40, 0x00, 0x00, 0x00, 0x00,
0x00, 0x0c, 0x00, 0x1a, 0x00, 0x1f, 0x00, 0xac,
0x01, 0x56, 0x00, 0xab, 0x03, 0x5b, 0x03, 0x86,
0x01, 0x0c, 0x03, 0xfc, 0x01, 0xfc, 0x00, 0xf8,
0x00, 0x20, 0x00, 0x20, 0x00, 0x50, 0x00, 0x00,
0x38, 0x00, 0x6c, 0x00, 0xc6, 0x00, 0xc6, 0x00,
0xc6, 0x00, 0x6c, 0x00, 0x38, 0x00, 0x20, 0x00,
0x38, 0x00, 0x28, 0x00, 0x38, 0x00, 0x78, 0x00,
0x7c, 0x20, 0xff, 0x20, 0xdf, 0xf0, 0x8f, 0xc0,
0x0e, 0x00, 0x17, 0x00, 0x27, 0x80, 0x27, 0x80,
0x27, 0x80, 0x17, 0x00, 0x0e, 0x00, 0x08, 0x00,
0x0e, 0x00, 0x0a, 0x00, 0x0e, 0x00, 0x1f, 0x00,
0x1f, 0x84, 0x3f, 0xe4, 0x37, 0xfe, 0x23, 0xf0,
0x03, 0x80, 0x07, 0x40, 0x0b, 0xa0, 0x0b, 0xa0,
0x0b, 0xa0, 0x07, 0x40, 0x03, 0x80, 0x02, 0x00,
0x03, 0x80, 0x02, 0x80, 0x03, 0x80, 0x07, 0x80,
0x07, 0xc4, 0x0f, 0xf4, 0x0d, 0xfe, 0x08, 0xf8,
0x00, 0xe0, 0x01, 0xd0, 0x03, 0xc8, 0x03, 0xc8,
0x03, 0xc8, 0x01, 0xd0, 0x00, 0xe0, 0x00, 0x80,
0x00, 0xe0, 0x00, 0xa0, 0x00, 0xe0, 0x01, 0xe0,
0x01, 0xf2, 0x03, 0xfa, 0x03, 0x7f, 0x02, 0x3c,
0x07, 0x00, 0x0b, 0x80, 0x13, 0xc0, 0x13, 0xc0,
0x13, 0xc0, 0x0b, 0x80, 0x07, 0x00, 0x01, 0x00,
0x07, 0x00, 0x05, 0x00, 0x07, 0x00, 0x07, 0x80,
0x4f, 0x80, 0x5f, 0xc0, 0xfe, 0xc0, 0x3c, 0x40,
0x01, 0xc0, 0x02, 0xe0, 0x05, 0xd0, 0x05, 0xd0,
0x05, 0xd0, 0x02, 0xe0, 0x01, 0xc0, 0x00, 0x40,
0x01, 0xc0, 0x01, 0x40, 0x01, 0xc0, 0x01, 0xe0,
0x23, 0xe0, 0x2f, 0xf0, 0x7f, 0xb0, 0x1f, 0x10,
0x00, 0x70, 0x00, 0xe8, 0x01, 0xe4, 0x01, 0xe4,
0x01, 0xe4, 0x00, 0xe8, 0x00, 0x70, 0x00, 0x10,
0x00, 0x70, 0x00, 0x50, 0x00, 0x70, 0x00, 0xf8,
0x21, 0xf8, 0x27, 0xfc, 0x7f, 0xec, 0x0f, 0xc4,
0x00, 0x1c, 0x00, 0x36, 0x00, 0x63, 0x00, 0x63,
0x00, 0x63, 0x00, 0x36, 0x00, 0x1c, 0x00, 0x04,
0x00, 0x1c, 0x00, 0x14, 0x00, 0x1c, 0x00, 0x1e,
0x04, 0x3e, 0x04, 0xff, 0x0f, 0xfb, 0x03, 0xf1,
0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0,
0x40, 0xc0, 0x30, 0xc0, 0x0c, 0xc0, 0x02, 0xc0,
0xfe, 0xc0, 0xff, 0xc0, 0xfe, 0x00, 0x7c, 0x00,
0x7b, 0x80, 0x3f, 0xc0, 0x3e, 0xc0, 0x3e, 0xc0,
0x00, 0x30, 0x00, 0x30, 0x04, 0x30, 0x02, 0x30,
0x02, 0x30, 0x01, 0x30, 0x01, 0x30, 0x00, 0xb0,
0x3f, 0xb0, 0x3f, 0xf0, 0x3f, 0x80, 0x1f, 0x00,
0x1e, 0xe0, 0x0f, 0xf0, 0x0f, 0xb0, 0x0f, 0xb0,
0x00, 0x0c, 0x00, 0x0c, 0x00, 0x0c, 0x00, 0x0c,
0x04, 0x0c, 0x03, 0x0c, 0x00, 0xcc, 0x00, 0x2c,
0x0f, 0xec, 0x0f, 0xfc, 0x0f, 0xe0, 0x07, 0xc0,
0x07, 0xb8, 0x03, 0xfc, 0x03, 0xec, 0x03, 0xec,
0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03,
0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x03, 0xfb,
0x03, 0xfb, 0x03, 0xff, 0x03, 0xf8, 0x01, 0xf0,
0x01, 0xee, 0x00, 0xff, 0x00, 0xfb, 0x00, 0xfb,
0xc0, 0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0, 0x00,
0xc0, 0x00, 0xc0, 0x00, 0xc0, 0x00, 0xdf, 0xc0,
0xdf, 0xc0, 0xff, 0xc0, 0x1f, 0xc0, 0x0f, 0x80,
0x77, 0x80, 0xff, 0x00, 0xdf, 0x00, 0xdf, 0x00,
0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00,
0x30, 0x20, 0x30, 0xc0, 0x33, 0x00, 0x34, 0x00,
0x37, 0xf0, 0x3f, 0xf0, 0x07, 0xf0, 0x03, 0xe0,
0x1d, 0xe0, 0x3f, 0xc0, 0x37, 0xc0, 0x37, 0xc0,
0x0c, 0x00, 0x0c, 0x00, 0x0c, 0x20, 0x0c, 0x40,
0x0c, 0x40, 0x0c, 0x80, 0x0c, 0x80, 0x0d, 0x00,
0x0d, 0xfc, 0x0f, 0xfc, 0x01, 0xfc, 0x00, 0xf8,
0x07, 0x78, 0x0f, 0xf0, 0x0d, 0xf0, 0x0d, 0xf0,
0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00,
0x03, 0x02, 0x03, 0x0c, 0x03, 0x30, 0x03, 0x40,
0x03, 0x7f, 0x03, 0xff, 0x00, 0x7f, 0x00, 0x3e,
0x01, 0xde, 0x03, 0xfc, 0x03, 0x7c, 0x03, 0x7c,
0x3e, 0x00, 0xf3, 0x80, 0x73, 0x80, 0x3f, 0xc0,
0x0f, 0xc0, 0x07, 0xc0, 0x0f, 0xc0, 0x3f, 0xc0,
0x7f, 0x80, 0xff, 0x80, 0x3e, 0x00, 0x14, 0x00,
0x14, 0x00, 0x3e, 0x00, 0x00, 0x00, 0x00, 0x00,
0x0f, 0x80, 0x3f, 0xe0, 0x7c, 0xe0, 0x1c, 0xf0,
0x07, 0xf0, 0x01, 0xf0, 0x07, 0xf0, 0x1f, 0xf0,
0x7f, 0xe0, 0x3f, 0xe0, 0x0f, 0x80, 0x0f, 0x80,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x03, 0xe0, 0x0f, 0xf8, 0x0e, 0x78, 0x1e, 0x7c,
0x1f, 0xfc, 0x00, 0x7c, 0x1f, 0xfc, 0x1f, 0xfc,
0x0f, 0xf8, 0x0f, 0xf8, 0x03, 0xe0, 0x01, 0x40,
0x01, 0x40, 0x03, 0xe0, 0x00, 0x00, 0x00, 0x00,
0x00, 0xf8, 0x03, 0xfe, 0x07, 0xce, 0x01, 0xcf,
0x00, 0x7f, 0x00, 0x1f, 0x00, 0x7f, 0x01, 0xff,
0x07, 0xfe, 0x03, 0xfe, 0x00, 0xf8, 0x00, 0x50,
0x00, 0x50, 0x00, 0x50, 0x00, 0x50, 0x00, 0xf8,
0x1f, 0x00, 0x7f, 0xc0, 0x73, 0xe0, 0xf3, 0x80,
0xfe, 0x00, 0xf8, 0x00, 0xfe, 0x00, 0xff, 0x80,
0x7f, 0xe0, 0x7f, 0xc0, 0x1f, 0x00, 0x0a, 0x00,
0x0a, 0x00, 0x0a, 0x00, 0x0a, 0x00, 0x1f, 0x00,
0x07, 0xc0, 0x1f, 0xf0, 0x1e, 0x70, 0x3e, 0x78,
0x3f, 0xf8, 0x3e, 0x00, 0x3f, 0xf8, 0x3f, 0xf8,
0x1f, 0xf0, 0x1f, 0xf0, 0x07, 0xc0, 0x02, 0x80,
0x02, 0x80, 0x07, 0xc0, 0x00, 0x00, 0x00, 0x00,
0x01, 0xf0, 0x07, 0xfc, 0x07, 0x3e, 0x0f, 0x38,
0x0f, 0xe0, 0x0f, 0x80, 0x0f, 0xe0, 0x0f, 0xf8,
0x07, 0xfe, 0x07, 0xfc, 0x01, 0xf0, 0x01, 0xf0,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x7c, 0x01, 0xcf, 0x01, 0xce, 0x03, 0xfc,
0x03, 0xf0, 0x03, 0xe0, 0x03, 0xf0, 0x03, 0xfc,
0x01, 0xfe, 0x01, 0xff, 0x00, 0x7c, 0x00, 0x28,
0x00, 0x28, 0x00, 0x7c, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x0e, 0x00,
0x54, 0x00, 0x7c, 0x00, 0x1c, 0x00, 0x0e, 0x00,
0x1e, 0x00, 0x2e, 0x00, 0x0f, 0x00, 0x1f, 0x00,
0x1f, 0x80, 0x0d, 0x80, 0x30, 0xc0, 0x00, 0x20,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x01, 0x80, 0x03, 0x80, 0x15, 0x00, 0x1f, 0x00,
0x07, 0x00, 0x03, 0x80, 0x07, 0x80, 0x0b, 0x80,
0x03, 0xc0, 0x07, 0xc0, 0x07, 0xe0, 0x1f, 0x7c,
0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0xe0,
0x05, 0x40, 0x07, 0xc0, 0x01, 0xc0, 0x00, 0xe0,
0x01, 0xe0, 0x02, 0xe0, 0x00, 0xf0, 0x01, 0xf0,
0x01, 0xf0, 0x01, 0xd8, 0x00, 0xcc, 0x03, 0x02,
0x00, 0x18, 0x00, 0x38, 0x01, 0x50, 0x01, 0xf0,
0x00, 0x30, 0x00, 0x38, 0x00, 0x78, 0x00, 0xb8,
0x00, 0x3c, 0x00, 0x7c, 0x00, 0x7c, 0x00, 0x76,
0x00, 0x22, 0x00, 0x42, 0x00, 0x81, 0x00, 0x00,
0x18, 0x00, 0x1c, 0x00, 0x0a, 0x80, 0x0f, 0x80,
0x0c, 0x00, 0x1c, 0x00, 0x1e, 0x00, 0x1d, 0x00,
0x3c, 0x00, 0x3e, 0x00, 0x3e, 0x00, 0x6e, 0x00,
0x44, 0x00, 0x42, 0x00, 0x81, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x06, 0x00, 0x07, 0x00,
0x02, 0xa0, 0x03, 0xe0, 0x03, 0x80, 0x07, 0x00,
0x07, 0x80, 0x07, 0x40, 0x0f, 0x00, 0x0f, 0x80,
0x0f, 0x80, 0x1b, 0x80, 0x33, 0x00, 0x40, 0xc0,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x01, 0x80, 0x01, 0xc0, 0x00, 0xa8, 0x00, 0xf8,
0x00, 0xe0, 0x01, 0xc0, 0x01, 0xe0, 0x01, 0xd0,
0x03, 0xc0, 0x03, 0xe0, 0x07, 0xe0, 0x3e, 0xf8,
0x00, 0x00, 0x00, 0x00, 0x00, 0x60, 0x00, 0x70,
0x00, 0x2a, 0x00, 0x3e, 0x00, 0x38, 0x00, 0x70,
0x00, 0x78, 0x00, 0x74, 0x00, 0xf0, 0x00, 0xf8,
0x01, 0xf8, 0x01, 0xb0, 0x03, 0x0c, 0x04, 0x00,
0x13, 0xc8, 0x1d, 0xb8, 0x0f, 0xf0, 0x06, 0x60,
0x05, 0xa0, 0x02, 0x40, 0x07, 0xe0, 0x0f, 0xf0,
0x1f, 0xf8, 0x33, 0xcc, 0x63, 0xc6, 0x46, 0x62,
0x2c, 0x34, 0x06, 0x60, 0x02, 0x40, 0x0e, 0x70,
0x0b, 0xd0, 0x0d, 0xb0, 0x0f, 0xf0, 0x06, 0x60,
0x05, 0xa0, 0x02, 0x40, 0x03, 0xc0, 0x1f, 0xf8,
0x7f, 0xfe, 0xe7, 0xe7, 0x83, 0xc1, 0xc7, 0xe3,
0x06, 0x60, 0x0c, 0x30, 0x08, 0x10, 0x38, 0x1c,
0x1c, 0x38, 0x06, 0x60, 0x0c, 0x30, 0x66, 0x66,
0x23, 0xc4, 0x67, 0xe6, 0x37, 0xec, 0x1f, 0xf8,
0x0f, 0xf0, 0x07, 0xe0, 0x02, 0x40, 0x05, 0xa0,
0x06, 0x60, 0x0f, 0xf0, 0x0d, 0xb0, 0x0b, 0xd0,
0x70, 0x0e, 0x18, 0x18, 0x0c, 0x30, 0x06, 0x60,
0x63, 0xc6, 0x27, 0xe4, 0x67, 0xe6, 0x37, 0xec,
0x1f, 0xf8, 0x0f, 0xf0, 0x02, 0x40, 0x05, 0xa0,
0x16, 0x68, 0x0f, 0xf0, 0x0d, 0xb0, 0x03, 0xc0,
0x08, 0x00, 0x05, 0x00, 0x08, 0x80, 0x25, 0x00,
0x48, 0x80, 0x21, 0x00, 0x4c, 0x00, 0x33, 0x00,
0x44, 0x80, 0x44, 0x80, 0x88, 0x40, 0x84, 0x40,
0x48, 0x80, 0x48, 0x80, 0x33, 0x00, 0x0c, 0x00,
0x02, 0x00, 0x11, 0x20, 0x0a, 0x40, 0x11, 0x20,
0x0a, 0x40, 0x10, 0x20, 0x03, 0x00, 0x0c, 0xc0,
0x10, 0x20, 0x10, 0x60, 0x22, 0x90, 0x25, 0x10,
0x18, 0x20, 0x10, 0x20, 0x0c, 0xc0, 0x03, 0x00,
0x00, 0x40, 0x02, 0x20, 0x04, 0x48, 0x02, 0x24,
0x04, 0x48, 0x02, 0x04, 0x00, 0xc8, 0x03, 0x30,
0x04, 0x08, 0x04, 0x08, 0x0b, 0x44, 0x08, 0xb4,
0x04, 0x08, 0x04, 0x08, 0x03, 0x30, 0x00, 0xc0,
0x00, 0x44, 0x01, 0x22, 0x02, 0x44, 0x01, 0x22,
0x02, 0x44, 0x01, 0x02, 0x02, 0x30, 0x00, 0xcc,
0x01, 0x42, 0x01, 0x22, 0x02, 0x11, 0x02, 0x21,
0x01, 0x12, 0x01, 0x0a, 0x00, 0xcc, 0x00, 0x30,
0x0a, 0x20, 0x16, 0x68, 0x01, 0x50, 0x39, 0x62,
0x65, 0xce, 0x03, 0xd0, 0xff, 0xee, 0x87, 0xf1,
0x77, 0xe4, 0xc7, 0xff, 0x8b, 0xf1, 0x32, 0xac,
0x64, 0xa6, 0x49, 0xa2, 0x12, 0x90, 0x36, 0x98,
0x00, 0x00, 0x05, 0x20, 0x03, 0x40, 0x31, 0x74,
0x1d, 0xcc, 0x03, 0xd0, 0x3f, 0xec, 0x07, 0xf4,
0x3f, 0xe0, 0x67, 0xfc, 0x0b, 0xf2, 0x32, 0xac,
0x24, 0xa4, 0x0b, 0x90, 0x1a, 0xd8, 0x00, 0xc0,
0x00, 0x00, 0x00, 0x00, 0x02, 0x20, 0x09, 0x60,
0x05, 0xc8, 0x03, 0xd0, 0x1f, 0xe0, 0x07, 0xf8,
0x1f, 0xe0, 0x17, 0xf8, 0x0f, 0xf0, 0x12, 0xa8,
0x05, 0xa0, 0x0a, 0xb0, 0x00, 0xc0, 0x00, 0x00,
0x00, 0x00, 0x05, 0x20, 0x03, 0x40, 0x31, 0x74,
0x1d, 0xcc, 0x03, 0xd0, 0x3f, 0xec, 0x07, 0xf4,
0x3f, 0xe0, 0x67, 0xfc, 0x0b, 0xf2, 0x32, 0xac,
0x24, 0xa4, 0x0b, 0x90, 0x1a, 0xd8, 0x00, 0xc0,
0x0c, 0x00, 0x0c, 0x00, 0x0c, 0x00, 0x0c, 0x00,
0x0c, 0x00, 0x0c, 0x00, 0x0c, 0x00, 0x0c, 0x00,
0x0c, 0x00, 0x0c, 0x00, 0xff, 0xc0, 0x0c, 0x00,
0x61, 0x80, 0xd2, 0xc0, 0xb3, 0x40, 0x61, 0x80,
0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00,
0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00,
0x03, 0x00, 0x03, 0x00, 0x3f, 0xf0, 0x03, 0x00,
0x18, 0x60, 0x24, 0xd0, 0x3c, 0xd0, 0x18, 0x60,
0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0,
0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0,
0x00, 0xc0, 0x00, 0xc0, 0x0f, 0xfc, 0x00, 0xc0,
0x06, 0x18, 0x0b, 0x34, 0x0d, 0x2c, 0x06, 0x18,
0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30,
0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30,
0x00, 0x30, 0x00, 0x30, 0x03, 0xff, 0x00, 0x30,
0x01, 0x86, 0x02, 0x4d, 0x03, 0xcd, 0x01, 0x86,
0x03, 0x80, 0x06, 0x80, 0x0f, 0x80, 0x0b, 0x00,
0x1f, 0x00, 0x1f, 0x00, 0x06, 0x00, 0x0f, 0x00,
0x1f, 0x80, 0x3f, 0xc0, 0x7f, 0xe0, 0x6f, 0x60,
0x1f, 0x00, 0x5b, 0x80, 0x70, 0xc0, 0x21, 0xc0,
0x00, 0xe0, 0x01, 0xa0, 0x03, 0xe0, 0x02, 0xc0,
0x07, 0xc0, 0x07, 0xc0, 0x01, 0x80, 0x03, 0xc0,
0x07, 0xe0, 0x07, 0xe0, 0x0e, 0xf0, 0x0d, 0xf0,
0x03, 0xc0, 0x06, 0xe0, 0x07, 0x60, 0x0e, 0xe0,
0x00, 0x38, 0x00, 0x68, 0x00, 0xf8, 0x00, 0xb0,
0x01, 0xf0, 0x01, 0xf0, 0x00, 0x60, 0x00, 0xf0,
0x01, 0xf8, 0x01, 0xd8, 0x01, 0xd8, 0x01, 0xb8,
0x00, 0xf0, 0x00, 0x60, 0x00, 0x60, 0x00, 0xe0,
0x00, 0x0e, 0x00, 0x1a, 0x00, 0x3e, 0x00, 0x2c,
0x00, 0x7c, 0x00, 0x7c, 0x00, 0x18, 0x00, 0x3c,
0x00, 0x7e, 0x00, 0x7e, 0x00, 0xef, 0x00, 0xdf,
0x00, 0x3c, 0x00, 0x6e, 0x00, 0x76, 0x00, 0xee,
0x70, 0x00, 0x50, 0x00, 0x7c, 0x00, 0x34, 0x00,
0x3e, 0x00, 0x3e, 0x00, 0x18, 0x00, 0x3c, 0x00,
0x7e, 0x00, 0x7e, 0x00, 0xf7, 0x00, 0xfb, 0x00,
0x3c, 0x00, 0x76, 0x00, 0x6e, 0x00, 0x77, 0x00,
0x1c, 0x00, 0x14, 0x00, 0x1f, 0x00, 0x0d, 0x00,
0x0f, 0x80, 0x0f, 0x80, 0x06, 0x00, 0x0f, 0x00,
0x1b, 0x80, 0x1b, 0x80, 0x1b, 0x80, 0x1d, 0x80,
0x0f, 0x00, 0x06, 0x00, 0x06, 0x00, 0x07, 0x00,
0x07, 0x00, 0x05, 0x00, 0x07, 0xc0, 0x03, 0x40,
0x03, 0xe0, 0x03, 0xe0, 0x01, 0x80, 0x03, 0xc0,
0x07, 0xe0, 0x07, 0xe0, 0x0f, 0x70, 0x0f, 0xb0,
0x03, 0xc0, 0x07, 0x60, 0x06, 0xe0, 0x07, 0x70,
0x01, 0xc0, 0x01, 0x40, 0x01, 0xf0, 0x00, 0xd0,
0x00, 0xf8, 0x00, 0xf8, 0x00, 0x60, 0x00, 0xf0,
0x01, 0xf8, 0x03, 0xfc, 0x07, 0xfe, 0x06, 0xf6,
0x00, 0xf8, 0x01, 0xda, 0x03, 0x0e, 0x03, 0x84,
0x00, 0x00, 0x00, 0x00, 0x3f, 0xfc, 0x63, 0xc6,
0xeb, 0xd7, 0xe8, 0x17, 0x0f, 0xf0, 0x07, 0xe0,
0x0c, 0x30, 0x0b, 0xd0, 0x1b, 0xd8, 0x1c, 0x38,
0x3f, 0xfc, 0x3f, 0xfc, 0x3f, 0xfc, 0x3f, 0xfc,
0x3c, 0x00, 0x7f, 0xc0, 0x7f, 0xf8, 0x63, 0xc6,
0x08, 0x57, 0x08, 0x17, 0x0f, 0xf7, 0x07, 0xe0,
0x0c, 0x30, 0x0b, 0xd0, 0x1b, 0xd8, 0x1c, 0x38,
0x3f, 0xfc, 0x3f, 0xfc, 0x3f, 0xfc, 0x3f, 0xfc,
0x00, 0x00, 0x00, 0x00, 0x3f, 0xfc, 0x63, 0xc6,
0xeb, 0xd7, 0xe8, 0x17, 0x0f, 0xf0, 0x07, 0xe0,
0x0c, 0x30, 0x0b, 0xd0, 0x1b, 0xd8, 0x1c, 0x38,
0x3f, 0xfc, 0x3f, 0xfc, 0x3f, 0xfc, 0x3f, 0xfc,
0x00, 0x3c, 0x03, 0xfe, 0x1f, 0xfe, 0x63, 0xc6,
0xea, 0x10, 0xe8, 0x10, 0xef, 0xf0, 0x07, 0xe0,
0x0c, 0x30, 0x0b, 0xd0, 0x1b, 0xd8, 0x1c, 0x38,
0x3f, 0xfc, 0x3f, 0xfc, 0x3f, 0xfc, 0x3f, 0xfc,
0x0c, 0x00, 0x16, 0x00, 0x2d, 0x00, 0x4c, 0x80,
0x8c, 0x40, 0x8c, 0x40, 0x4c, 0x80, 0x2d, 0x00,
0x16, 0x00, 0x0c, 0x00, 0x37, 0x00, 0x4c, 0x00,
0x7f, 0xc0, 0xff, 0xc0, 0x40, 0x80, 0x2e, 0x00,
0x03, 0x00, 0x03, 0x00, 0x05, 0x80, 0x07, 0x80,
0x0b, 0x40, 0x0b, 0x40, 0x07, 0x80, 0x05, 0x80,
0x03, 0x00, 0x03, 0x00, 0x0e, 0xc0, 0x03, 0x20,
0x3f, 0xe0, 0x3f, 0xf0, 0x10, 0x20, 0x07, 0x40,
0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0,
0x00, 0x80, 0x00, 0x80, 0x00, 0xc0, 0x00, 0xc0,
0x00, 0xc0, 0x00, 0xc0, 0x01, 0xd0, 0x04, 0xc8,
0x0f, 0xfc, 0x0f, 0xf8, 0x00, 0x08, 0x03, 0xb0,
0x00, 0x30, 0x00, 0x68, 0x00, 0xb4, 0x00, 0xb4,
0x01, 0x32, 0x01, 0x32, 0x00, 0xb4, 0x00, 0xb4,
0x00, 0x68, 0x00, 0x30, 0x00, 0xb8, 0x01, 0x32,
0x03, 0xff, 0x01, 0xff, 0x01, 0x00, 0x00, 0xdc,
0x13, 0xc8, 0x1d, 0xb8, 0x0f, 0xf0, 0x06, 0x60,
0x05, 0xa0, 0x02, 0x40, 0x07, 0xe0, 0x0f, 0xf0,
0x1f, 0xf8, 0x33, 0xcc, 0x63, 0xc6, 0x46, 0x62,
0x2c, 0x34, 0x06, 0x60, 0x02, 0x40, 0x0e, 0x70,
0x0b, 0xd0, 0x0d, 0xb0, 0x0f, 0xf0, 0x06, 0x60,
0x05, 0xa0, 0x02, 0x40, 0x03, 0xc0, 0x1f, 0xf8,
0x7f, 0xfe, 0xe7, 0xe7, 0x83, 0xc1, 0xc7, 0xe3,
0x06, 0x60, 0x0c, 0x30, 0x08, 0x10, 0x38, 0x1c,
0x1c, 0x38, 0x06, 0x60, 0x0c, 0x30, 0x66, 0x66,
0x23, 0xc4, 0x67, 0xe6, 0x37, 0xec, 0x1f, 0xf8,
0x0f, 0xf0, 0x07, 0xe0, 0x02, 0x40, 0x05, 0xa0,
0x06, 0x60, 0x0f, 0xf0, 0x0d, 0xb0, 0x0b, 0xd0,
0x70, 0x0e, 0x18, 0x18, 0x0c, 0x30, 0x06, 0x60,
0x63, 0xc6, 0x27, 0xe4, 0x67, 0xe6, 0x37, 0xec,
0x1f, 0xf8, 0x0f, 0xf0, 0x02, 0x40, 0x05, 0xa0,
0x16, 0x68, 0x0f, 0xf0, 0x0d, 0xb0, 0x03, 0xc0,
0x08, 0x00, 0x05, 0x00, 0x08, 0x80, 0x25, 0x00,
0x48, 0x80, 0x21, 0x00, 0x4c, 0x00, 0x33, 0x00,
0x44, 0x80, 0x44, 0x80, 0x88, 0x40, 0x84, 0x40,
0x48, 0x80, 0x48, 0x80, 0x33, 0x00, 0x0c, 0x00,
0x02, 0x00, 0x11, 0x20, 0x0a, 0x40, 0x11, 0x20,
0x0a, 0x40, 0x10, 0x20, 0x03, 0x00, 0x0c, 0xc0,
0x10, 0x20, 0x10, 0x60, 0x22, 0x90, 0x25, 0x10,
0x18, 0x20, 0x10, 0x20, 0x0c, 0xc0, 0x03, 0x00,
0x00, 0x40, 0x02, 0x20, 0x04, 0x48, 0x02, 0x24,
0x04, 0x48, 0x02, 0x04, 0x00, 0xc8, 0x03, 0x30,
0x04, 0x08, 0x04, 0x08, 0x0b, 0x44, 0x08, 0xb4,
0x04, 0x08, 0x04, 0x08, 0x03, 0x30, 0x00, 0xc0,
0x00, 0x44, 0x01, 0x22, 0x02, 0x44, 0x01, 0x22,
0x02, 0x44, 0x01, 0x02, 0x02, 0x30, 0x00, 0xcc,
0x01, 0x42, 0x01, 0x22, 0x02, 0x11, 0x02, 0x21,
0x01, 0x12, 0x01, 0x0a, 0x00, 0xcc, 0x00, 0x30,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xc0,
0x0c, 0x30, 0x10, 0x08, 0x20, 0x04, 0x40, 0x02,
0x80, 0x01, 0x40, 0x02, 0x20, 0x04, 0xd0, 0x0b,
0x2c, 0x34, 0x4b, 0xd2, 0x12, 0x48, 0x02, 0x40,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xc0,
0x0c, 0x30, 0x10, 0x08, 0x20, 0x04, 0x40, 0x02,
0xf8, 0x1f, 0x57, 0xea, 0x2b, 0xd4, 0x12, 0x48,
0x0c, 0x30, 0x03, 0xc0, 0x00, 0x00, 0x00, 0x00,
0x04, 0x20, 0x04, 0x20, 0x12, 0x48, 0x4b, 0xd2,
0x2c, 0x34, 0x93, 0xc9, 0xa7, 0xe5, 0x46, 0x62,
0x86, 0x61, 0x47, 0xe2, 0x23, 0xc4, 0x10, 0x08,
0x0c, 0x30, 0x03, 0xc0, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xc0,
0x0c, 0x30, 0x12, 0x48, 0x2a, 0x54, 0x5f, 0xfa,
0xf6, 0x7f, 0x47, 0xe2, 0x23, 0xc4, 0x10, 0x08,
0x0c, 0x30, 0x03, 0xc0, 0x00, 0x00, 0x00, 0x00,
0x61, 0x80, 0xb2, 0x40, 0xb3, 0xc0, 0x61, 0x80,
0x0c, 0x00, 0xff, 0xc0, 0x52, 0x80, 0x12, 0x00,
0x12, 0x00, 0x1e, 0x00, 0x0c, 0x00, 0x0c, 0x00,
0x0c, 0x00, 0x0c, 0x00, 0x1e, 0x00, 0x3f, 0x00,
0x18, 0x60, 0x24, 0xd0, 0x3c, 0xd0, 0x18, 0x60,
0x03, 0x00, 0x3f, 0xf0, 0x14, 0xa0, 0x04, 0x80,
0x04, 0x80, 0x07, 0x80, 0x03, 0x00, 0x03, 0x00,
0x07, 0x80, 0x0f, 0xc0, 0x00, 0x00, 0x00, 0x00,
0x06, 0x18, 0x0d, 0x3c, 0x0d, 0x24, 0x06, 0x18,
0x00, 0xc0, 0x0f, 0xfc, 0x05, 0x28, 0x01, 0x20,
0x01, 0x20, 0x01, 0xe0, 0x01, 0xe0, 0x03, 0xf0,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x01, 0x86, 0x03, 0xcb, 0x02, 0x4b, 0x01, 0x86,
0x00, 0x30, 0x03, 0xff, 0x01, 0x4a, 0x00, 0x48,
0x00, 0x48, 0x00, 0x78, 0x00, 0x30, 0x00, 0x30,
0x00, 0x78, 0x00, 0xfc, 0x00, 0x00, 0x00, 0x00,
0x03, 0xc0, 0xff, 0xff, 0xab, 0xd5, 0xff, 0xff,
0x13, 0xc8, 0x29, 0x94, 0x15, 0xa8, 0x0b, 0xd0,
0x05, 0xa0, 0x03, 0xc0, 0x03, 0xc0, 0x05, 0xa0,
0x0a, 0x50, 0x14, 0x28, 0x28, 0x14, 0x10, 0x08,
0x00, 0x00, 0x00, 0x00, 0x03, 0xc0, 0xff, 0xff,
0xab, 0xd5, 0xff, 0xff, 0x13, 0xc8, 0x29, 0x94,
0x15, 0xa8, 0x0b, 0xd0, 0x05, 0xa0, 0x03, 0xc0,
0x03, 0xc0, 0x25, 0xa0, 0x4a, 0x54, 0x14, 0x2a,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07,
0x03, 0xfd, 0xff, 0xd7, 0xab, 0xf8, 0xff, 0xc0,
0x03, 0xc0, 0x01, 0x80, 0x15, 0xa4, 0x4b, 0xd2,
0x05, 0xa4, 0x23, 0xc2, 0x0b, 0xd0, 0x25, 0xa8,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20,
0x02, 0x02, 0x00, 0x15, 0x03, 0xce, 0x0f, 0xd4,
0xcb, 0xc8, 0xb7, 0xc2, 0xe3, 0xc8, 0x31, 0x81,
0x07, 0xe4, 0xc3, 0xc8, 0x17, 0xc2, 0x23, 0xfc,
0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0x08, 0x20,
0x00, 0x00, 0x00, 0x00, 0x21, 0x02, 0x00, 0x11,
0x03, 0x8a, 0x0e, 0x90, 0x4b, 0xc0, 0x37, 0x02,
0x62, 0xc0, 0x31, 0x01, 0x05, 0xe2, 0xc3, 0x44,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x02, 0x00, 0x00, 0x00, 0x00, 0x20,
0x10, 0x08, 0x0a, 0x84, 0x00, 0x20, 0x65, 0x00,
0x22, 0x68, 0x08, 0xa0, 0x03, 0xd0, 0x17, 0xe0,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x02, 0x00, 0x00, 0x20, 0x10, 0x00, 0x00, 0x00,
0x05, 0x10, 0x00, 0x68, 0x22, 0xa0, 0x0d, 0xd0,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80,
0x00, 0x20, 0x08, 0x00, 0x02, 0xc0, 0x07, 0x60,
0x61, 0x86, 0x9f, 0xf9, 0x9f, 0xf9, 0x61, 0x86,
0x03, 0xc0, 0xff, 0xff, 0x80, 0x01, 0xaa, 0xa9,
0x9f, 0xfd, 0xb5, 0x59, 0x90, 0x0d, 0xb5, 0x59,
0x9f, 0xfd, 0xaa, 0xa9, 0x80, 0x01, 0xff, 0xff,
0x1d, 0xb8, 0x22, 0xf4, 0x22, 0xf4, 0x1d, 0xb8,
0x03, 0xc0, 0xff, 0xff, 0xd5, 0x55, 0xbf, 0xff,
0xea, 0xad, 0xb0, 0x07, 0xe5, 0x4d, 0xb0, 0x07,
0xea, 0xad, 0xbf, 0xff, 0xd5, 0x55, 0xff, 0xff,
0x07, 0xe0, 0x08, 0x10, 0x08, 0x10, 0x07, 0xe0,
0x03, 0xc0, 0xff, 0xff, 0xff, 0xff, 0xd5, 0x57,
0xe0, 0x03, 0xca, 0xa7, 0xe7, 0xf3, 0xca, 0xa7,
0xe0, 0x03, 0xd5, 0x57, 0xff, 0xff, 0xff, 0xff,
0x1d, 0xb8, 0x2f, 0x44, 0x2f, 0x44, 0x1d, 0xb8,
0x03, 0xc0, 0xff, 0xff, 0xaa, 0xab, 0xc0, 0x01,
0x95, 0x53, 0xcf, 0xf9, 0x9a, 0xb3, 0xcf, 0xf9,
0x95, 0x53, 0xc0, 0x01, 0xaa, 0xab, 0xff, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0xff, 0xc0, 0x81, 0xc0,
0xff, 0xc0, 0x82, 0x40, 0xfe, 0x40, 0xff, 0xc0,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x3f, 0xf0, 0x20, 0x70,
0x3f, 0xf0, 0x20, 0x90, 0x3f, 0x90, 0x3f, 0xf0,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x0f, 0xfc, 0x08, 0x1c, 0x0f, 0xfc, 0x08, 0x24,
0x0f, 0xe4, 0x0f, 0xfc, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x03, 0xff, 0x02, 0x07,
0x03, 0xff, 0x02, 0x09, 0x03, 0xf9, 0x03, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x02, 0xa0, 0x01, 0x50, 0x02, 0xa0, 0x01, 0x50,
0x02, 0x00, 0x02, 0x00, 0x02, 0x00, 0xc2, 0x00,
0xc1, 0x00, 0x21, 0x00, 0x7f, 0x00, 0xff, 0x00,
0x7e, 0x00, 0x3c, 0x00, 0x54, 0x00, 0x92, 0x00,
0x00, 0x00, 0x00, 0x08, 0x00, 0x14, 0x00, 0x2a,
0x00, 0x55, 0x00, 0x8a, 0x00, 0x84, 0x30, 0x80,
0x30, 0x40, 0x08, 0x40, 0x1f, 0xc0, 0x3f, 0xc0,
0x1f, 0x80, 0x0f, 0x00, 0x15, 0x00, 0x24, 0x80,
0x00, 0x54, 0x00, 0xa8, 0x00, 0x54, 0x00, 0xa8,
0x00, 0x04, 0x00, 0x04, 0x00, 0x04, 0x0c, 0x04,
0x0c, 0x04, 0x02, 0x08, 0x07, 0xf8, 0x0f, 0xf0,
0x07, 0xe0, 0x03, 0xc0, 0x05, 0x40, 0x09, 0x20,
0x00, 0x00, 0x00, 0x10, 0x00, 0x28, 0x00, 0x54,
0x00, 0xaa, 0x00, 0x52, 0x00, 0x21, 0x03, 0x01,
0x03, 0x01, 0x00, 0x82, 0x01, 0xfe, 0x03, 0xfc,
0x01, 0xf8, 0x00, 0xf0, 0x01, 0x50, 0x02, 0x48,
0x00, 0x00, 0x08, 0x00, 0x14, 0x00, 0x2a, 0x00,
0x55, 0x00, 0x4a, 0x00, 0x84, 0x00, 0x80, 0xc0,
0x80, 0xc0, 0x41, 0x00, 0x7f, 0x80, 0x3f, 0xc0,
0x1f, 0x80, 0x0f, 0x00, 0x0a, 0x80, 0x12, 0x40,
0x2a, 0x00, 0x15, 0x00, 0x2a, 0x00, 0x15, 0x00,
0x20, 0x00, 0x20, 0x00, 0x20, 0x00, 0x20, 0x30,
0x20, 0x30, 0x10, 0x40, 0x1f, 0xe0, 0x0f, 0xf0,
0x07, 0xe0, 0x03, 0xc0, 0x02, 0xa0, 0x04, 0x90,
0x00, 0x00, 0x10, 0x00, 0x28, 0x00, 0x54, 0x00,
0xaa, 0x00, 0x51, 0x00, 0x21, 0x00, 0x01, 0x0c,
0x02, 0x0c, 0x02, 0x10, 0x03, 0xf8, 0x03, 0xfc,
0x01, 0xf8, 0x00, 0xf0, 0x00, 0xa8, 0x01, 0x24,
0x05, 0x40, 0x0a, 0x80, 0x05, 0x40, 0x0a, 0x80,
0x00, 0x40, 0x00, 0x40, 0x00, 0x40, 0x00, 0x43,
0x00, 0x83, 0x00, 0x84, 0x00, 0xfe, 0x00, 0xff,
0x00, 0x7e, 0x00, 0x3c, 0x00, 0x2a, 0x00, 0x49,
0x55, 0x55, 0xff, 0xff, 0xff, 0xff, 0x08, 0x10,
0x08, 0x10, 0x08, 0x10, 0xf8, 0x1f, 0x55, 0x55,
0xff, 0xff, 0xff, 0xff, 0x08, 0x10, 0x08, 0x10,
0x08, 0x10, 0x58, 0x15, 0xff, 0xff, 0xff, 0xff,
0x00, 0x00, 0x55, 0x55, 0xff, 0xff, 0xff, 0xff,
0x08, 0x10, 0xf8, 0x1f, 0x08, 0x10, 0x3f, 0xfe,
0x38, 0x1e, 0x08, 0x10, 0x5f, 0xf5, 0xff, 0xff,
0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x55, 0x55,
0xff, 0xff, 0xff, 0xff, 0x08, 0x10, 0x38, 0x1e,
0x3f, 0xfe, 0x08, 0x10, 0xf8, 0x1f, 0x5f, 0xf5,
0xff, 0xff, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x55, 0x55, 0xff, 0xff, 0xf8, 0x1f,
0x08, 0x10, 0x55, 0x55, 0xff, 0xff, 0xff, 0xff,
0x78, 0x1d, 0xf8, 0x1f, 0xf8, 0x1f, 0x08, 0x10,
0x55, 0x55, 0xff, 0xff, 0xff, 0xff, 0x00, 0x00,
0x7e, 0x00, 0x99, 0x00, 0xff, 0x00, 0xdb, 0x00,
0xe7, 0x00, 0x7e, 0x00, 0x24, 0x00, 0x24, 0x00,
0x24, 0x00, 0x42, 0x00, 0x42, 0x00, 0x42, 0x00,
0x81, 0x00, 0x81, 0x00, 0xc3, 0x00, 0xc3, 0x00,
0x00, 0x00, 0x1f, 0x80, 0x26, 0x40, 0x3f, 0xc0,
0x36, 0xc0, 0x39, 0xc0, 0x1f, 0x80, 0x10, 0x80,
0x20, 0x40, 0x20, 0x40, 0x40, 0x20, 0x40, 0x20,
0x80, 0x10, 0x80, 0x30, 0xc0, 0x30, 0xc0, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x07, 0xe0,
0x09, 0x90, 0x0f, 0xf0, 0x0d, 0xb0, 0x0e, 0x70,
0x07, 0xe0, 0x08, 0x10, 0x10, 0x08, 0x20, 0x04,
0x40, 0x02, 0x80, 0x01, 0xc0, 0x03, 0xc0, 0x03,
0x00, 0x00, 0x01, 0xf8, 0x02, 0x64, 0x03, 0xfc,
0x03, 0x6c, 0x03, 0x9c, 0x01, 0xf8, 0x01, 0x08,
0x02, 0x04, 0x02, 0x04, 0x04, 0x02, 0x04, 0x02,
0x08, 0x01, 0x0c, 0x01, 0x0c, 0x03, 0x00, 0x03,
0x03, 0xc0, 0x0e, 0x70, 0x13, 0xc8, 0x31, 0x8c,
0x39, 0x9c, 0x5f, 0xfa, 0x8d, 0xb2, 0x84, 0xa4,
0x49, 0x24, 0x29, 0x12, 0x24, 0x89, 0x42, 0x49,
0x82, 0x52, 0x04, 0x90, 0x08, 0x88, 0x00, 0x40,
0x03, 0xc0, 0x0e, 0x70, 0x13, 0xc8, 0x31, 0x8c,
0x39, 0x9c, 0x5f, 0xfa, 0x4d, 0xb1, 0x85, 0x11,
0x84, 0x92, 0x48, 0xa4, 0x29, 0x24, 0x29, 0x12,
0x44, 0x89, 0x02, 0x48, 0x02, 0x50, 0x04, 0x00,
0x03, 0xc0, 0x0e, 0x70, 0x13, 0xc8, 0x31, 0x8c,
0x39, 0x9c, 0x5f, 0xfa, 0x4d, 0xb1, 0x44, 0x91,
0x82, 0x49, 0x82, 0x4a, 0x44, 0x94, 0x25, 0x24,
0x29, 0x22, 0x08, 0x90, 0x04, 0x48, 0x00, 0x40,
0x03, 0xc0, 0x0e, 0x70, 0x13, 0xc8, 0x31, 0x8c,
0x39, 0x9c, 0x5f, 0xfa, 0x4d, 0xb2, 0x29, 0x12,
0x24, 0x91, 0x42, 0x49, 0x82, 0x4a, 0x84, 0x4a,
0x48, 0x91, 0x09, 0x20, 0x09, 0x00, 0x00, 0x80,
0x0c, 0x00, 0x0c, 0x00, 0x0c, 0x00, 0x0c, 0x00,
0x0c, 0x00, 0x0c, 0x00, 0x0c, 0x00, 0x0c, 0x00,
0x0c, 0x00, 0x0c, 0x00, 0xff, 0xc0, 0x0c, 0x00,
0x61, 0x80, 0xd2, 0xc0, 0xb3, 0x40, 0x61, 0x80,
0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00,
0x03, 0x00, 0x03, 0x00, 0x03, 0x00, 0x03, 0x00,
0x03, 0x00, 0x03, 0x00, 0x3f, 0xf0, 0x03, 0x00,
0x18, 0x60, 0x24, 0xd0, 0x3c, 0xd0, 0x18, 0x60,
0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0,
0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0, 0x00, 0xc0,
0x00, 0xc0, 0x00, 0xc0, 0x0f, 0xfc, 0x00, 0xc0,
0x06, 0x18, 0x0b, 0x34, 0x0d, 0x2c, 0x06, 0x18,
0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30,
0x00, 0x30, 0x00, 0x30, 0x00, 0x30, 0x00, 0x30,
0x00, 0x30, 0x00, 0x30, 0x03, 0xff, 0x00, 0x30,
0x01, 0x86, 0x02, 0x4d, 0x03, 0xcd, 0x01, 0x86,
0x03, 0x40, 0x0f, 0x70, 0x3f, 0x3c, 0x3f, 0x4c,
0x5f, 0x66, 0x5f, 0x76, 0x9f, 0x7f, 0x00, 0x7f,
0x8e, 0x00, 0x8e, 0xff, 0x46, 0xfe, 0x40, 0xf2,
0x20, 0x04, 0x30, 0x0c, 0x0c, 0x30, 0x02, 0xc0,
0x03, 0xc0, 0x0f, 0xf0, 0x3f, 0xac, 0x3f, 0xcc,
0x5f, 0xc6, 0x47, 0xb6, 0x99, 0xbf, 0x9e, 0x7f,
0x8e, 0x7f, 0x8d, 0x9f, 0x45, 0xe6, 0x41, 0xf2,
0x20, 0x04, 0x30, 0x0c, 0x0c, 0x30, 0x03, 0xc0,
0x03, 0xc0, 0x0f, 0xf0, 0x2f, 0xbc, 0x37, 0xc8,
0x5b, 0xe6, 0x5d, 0xe6, 0x9e, 0xdf, 0x9e, 0x3f,
0x8c, 0x7f, 0x8b, 0x7f, 0x47, 0xbe, 0x41, 0xc2,
0x00, 0x04, 0x30, 0x04, 0x0c, 0x30, 0x03, 0xc0,
0x03, 0xc0, 0x0b, 0xf0, 0x3d, 0xbc, 0x3d, 0xcc,
0x5d, 0xe6, 0x5e, 0xf4, 0x9e, 0xe3, 0x9e, 0x1f,
0x88, 0x7f, 0x87, 0x7f, 0x07, 0x7e, 0x41, 0xb2,
0x20, 0x04, 0x30, 0x0c, 0x0c, 0x10, 0x03, 0xc0,
0x06, 0x00, 0x0c, 0x00, 0x18, 0x00, 0x38, 0x00,
0x74, 0x00, 0xca, 0x80, 0x85, 0xc0, 0x03, 0xc0,
0x06, 0x40, 0xce, 0xc0, 0xd8, 0x40, 0xff, 0xc0,
0xe2, 0x00, 0xc8, 0x80, 0xd5, 0x40, 0x08, 0x80,
0x01, 0x80, 0x03, 0x00, 0x06, 0x00, 0x0e, 0x00,
0x1d, 0x00, 0x32, 0xa0, 0x21, 0x70, 0x00, 0xf0,
0x01, 0x90, 0x63, 0xb0, 0x66, 0x10, 0x7f, 0xf0,
0x78, 0x80, 0x62, 0x20, 0x65, 0x50, 0x02, 0x20,
0x00, 0x60, 0x00, 0xc0, 0x01, 0x80, 0x03, 0x80,
0x07, 0x40, 0x0c, 0xa8, 0x08, 0x5c, 0x00, 0x3c,
0x00, 0x64, 0x30, 0xec, 0x31, 0x84, 0x3f, 0xfc,
0x3e, 0x20, 0x30, 0x88, 0x31, 0x54, 0x00, 0x88,
0x00, 0x18, 0x00, 0x30, 0x00, 0x60, 0x00, 0xe0,
0x01, 0xd0, 0x03, 0x2a, 0x02, 0x17, 0x00, 0x0f,
0x00, 0x19, 0x06, 0x3b, 0x06, 0x61, 0x07, 0xff,
0x07, 0x88, 0x06, 0x22, 0x06, 0x55, 0x00, 0x22,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xc0,
0x0c, 0x30, 0x10, 0x08, 0x20, 0x04, 0x40, 0x02,
0x80, 0x01, 0x40, 0x02, 0x20, 0x04, 0xd0, 0x0b,
0x2c, 0x34, 0x4b, 0xd2, 0x12, 0x48, 0x02, 0x40,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xc0,
0x0c, 0x30, 0x10, 0x08, 0x20, 0x04, 0x40, 0x02,
0xf8, 0x1f, 0x57, 0xea, 0x2b, 0xd4, 0x12, 0x48,
0x0c, 0x30, 0x03, 0xc0, 0x00, 0x00, 0x00, 0x00,
0x04, 0x20, 0x04, 0x20, 0x12, 0x48, 0x4b, 0xd2,
0x2c, 0x34, 0x93, 0xc9, 0xa7, 0x00, 0x00, 0x00,
0x00, 0x01, 0x03, 0x02, 0x00, 0x18, 0x30, 0x60,
0xe0, 0xd0, 0x2a, 0x17, 0x0f, 0x00, 0x06, 0x06,
0x07, 0x07, 0x06, 0x06, 0x00, 0x19, 0x3b, 0x61,
0xff, 0x88, 0x22, 0x55, 0x22, 0x54, 0x5f, 0xfa,
0xf6, 0x7f, 0x47, 0xe2, 0x23, 0xc4, 0x10, 0x08,
0x0c, 0x30, 0x03, 0xc0, 0x00, 0x00, 0x00, 0x00,
0x12, 0x00, 0x0c, 0x00, 0x1e, 0x00, 0xbf, 0x40,
0x73, 0x80, 0x73, 0x80, 0xbf, 0x40, 0x5e, 0x80,
0x4c, 0x80, 0x52, 0x80, 0x7f, 0x80, 0x0c, 0x00,
0x61, 0x80, 0x92, 0xc0, 0xb2, 0x40, 0x61, 0x80,
0x03, 0x00, 0x07, 0x80, 0x07, 0x80, 0x1c, 0xe0,
0x3b, 0x70, 0x3b, 0x70, 0x1c, 0xe0, 0x17, 0xa0,
0x17, 0xa0, 0x13, 0x20, 0x1f, 0xe0, 0x03, 0x00,
0x18, 0x60, 0x24, 0x90, 0x34, 0xb0, 0x18, 0x60,
0x01, 0xe0, 0x01, 0xe0, 0x01, 0x20, 0x0e, 0xdc,
0x0d, 0xec, 0x0d, 0xec, 0x0e, 0xdc, 0x05, 0x28,
0x05, 0xe8, 0x05, 0xe8, 0x07, 0xf8, 0x00, 0xc0,
0x06, 0x18, 0x0d, 0x24, 0x09, 0x34, 0x06, 0x18,
0x00, 0x78, 0x00, 0x48, 0x00, 0x30, 0x03, 0x7b,
0x02, 0xfd, 0x02, 0xfd, 0x03, 0x7b, 0x01, 0x32,
0x01, 0x4a, 0x01, 0x7a, 0x01, 0x0f, 0x0c, 0x09,
0x4c, 0x44, 0x09, 0x28, 0x44, 0x45, 0x4d, 0x4f,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0xd5, 0xdd, 0xe5, 0xdd, 0x21, 0x4a, 0xea, 0x11,
0x04, 0x00, 0xdd, 0x46, 0x00, 0xdd, 0x23, 0x78,
0xb7, 0x28, 0x30, 0x3a, 0x20, 0x84, 0xdd, 0xbe,
0x00, 0x20, 0x24, 0x3a, 0xcf, 0x85, 0xdd, 0xbe,
0x01, 0x20, 0x1c, 0x3a, 0xd3, 0x85, 0xe6, 0x1f,
0xdd, 0xbe, 0x02, 0x20, 0x12, 0xdd, 0x7e, 0x03,
0x32, 0x20, 0x84, 0xe5, 0x00, 0x00, 0x00, 0xe1,
0xdd, 0xe1, 0xd1, 0xc1, 0xc3, 0x12, 0x89, 0xdd,
0x19, 0x10, 0xd0, 0xdd, 0xe1, 0xd1, 0x01, 0xfe,
0xef, 0xc9, 0x01, 0x3d, 0x80, 0x1d, 0x3e, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x28, 0x19, 0x47, 0x0e, 0x00, 0xe5, 0xc5, 0x3a,
0xe1, 0x85, 0x07, 0x07, 0x07, 0xe6, 0x60, 0x5f,
0x16, 0x9d, 0xcd, 0x56, 0x94, 0xc1, 0xe1, 0x23,
0x23, 0x10, 0xe8, 0xf5, 0xd5, 0x3a, 0xe3, 0x85,
0xfe, 0x0a, 0x20, 0x0a, 0xe5, 0x11, 0x40, 0x9c,
0xcd, 0x56, 0x94, 0xe1, 0x23, 0x23, 0x3a, 0x00,
0xc4, 0xfe, 0x09, 0x20, 0x0a, 0xe5, 0x11, 0x66,
0xeb, 0xcd, 0x56, 0x94, 0xe1, 0x23, 0x23, 0x3a,
0xba, 0x90, 0xfe, 0x32, 0x11, 0x86, 0xeb, 0x20,
0x03, 0x11, 0xc6, 0xeb, 0xe5, 0xcd, 0x56, 0x94,
0xe1, 0x23, 0x23, 0x3a, 0x5b, 0x8e, 0xfe, 0xc3,
0x11, 0xa6, 0xeb, 0x28, 0x03, 0x11, 0xc6, 0xeb,
0xcd, 0x56, 0x94, 0xd1, 0xf1, 0xc9, 0x00, 0x00,
0x00, 0x00, 0x0c, 0x30, 0x0c, 0x30, 0x3f, 0xfc,
0x3f, 0xfc, 0x0c, 0x30, 0x0c, 0x30, 0x0c, 0x30,
0x0c, 0x30, 0x3f, 0xfc, 0x3f, 0xfc, 0x0c, 0x30,
0x0c, 0x30, 0x00, 0x00, 0x00, 0x00, 0x5b, 0xda,
0x53, 0xca, 0x57, 0xea, 0x53, 0x4a, 0x5b, 0xea,
0x4b, 0xca, 0xd9, 0x9b, 0x93, 0xc9, 0xb7, 0xed,
0xa7, 0xe5, 0xaf, 0x75, 0xaf, 0xb5, 0xa3, 0xc5,
0xb7, 0x6d, 0x96, 0xe5, 0xd7, 0x75, 0x00, 0x1e,
0x00, 0x1e, 0x1c, 0x3f, 0x23, 0x1a, 0x3c, 0x9f,
0x3f, 0x5e, 0x3f, 0xec, 0x3f, 0xfe, 0x3f, 0x37,
0x1e, 0x37, 0x1e, 0x37, 0x1c, 0x3b, 0x1c, 0x1e,
0x08, 0x0c, 0x00, 0x0c, 0x00, 0x0e, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xed,
0x78, 0xe6, 0x08, 0xc2, 0x24, 0xec, 0x3a, 0xba,
0x90, 0xee, 0x08, 0x32, 0xba, 0x90, 0x18, 0x24,
0x3a, 0x00, 0xc4, 0xfe, 0x09, 0x20, 0x1e, 0xc5,
0x01, 0xfe, 0xfe, 0xed, 0x78, 0xe6, 0x01, 0x20,
0x13, 0x06, 0xfd, 0xed, 0x78, 0xe6, 0x10, 0xc2,
0xef, 0xeb, 0x3a, 0x5b, 0x8e, 0xee, 0x01, 0x32,
0x5b, 0x8e, 0x00, 0x00, 0xc1, 0x3a, 0xa0, 0x80,
0xc9, 0x00, 0x7b, 0x75, 0xf0, 0x79, 0xc1, 0x7a,
0x28, 0x14, 0x2c, 0x14, 0x31, 0x14, 0x2c, 0x14,
0x31, 0x14, 0x34, 0x14, 0xfc, 0x03, 0x03, 0xf7,
0x2c, 0x14, 0x33, 0x14, 0x36, 0x14, 0xfc, 0x04,
0x04, 0xf7, 0x2c, 0x14, 0x31, 0x14, 0x34, 0x14,
0x2c, 0x14, 0x31, 0x14, 0x34, 0x14, 0x2d, 0x14,
0x31, 0x14, 0x36, 0x14, 0x2d, 0x14, 0x31, 0x14,
0x36, 0x14, 0x2c, 0x14, 0x2f, 0x14, 0x34, 0x14,
0x2c, 0x14, 0x2f, 0x14, 0x34, 0x14, 0x2d, 0x14,
0x2f, 0x14, 0x33, 0x14, 0x2d, 0x14, 0x2f, 0x14,
0x33, 0x14, 0xfd, 0xfb, 0x09, 0x2c, 0x14, 0x31,
0x14, 0x34, 0x14, 0xfc, 0x08, 0x08, 0xf7, 0x2d,
0x14, 0x31, 0x14, 0x34, 0x14, 0x2d, 0x14, 0x31,
0x14, 0x34, 0x14, 0x2d, 0x14, 0x32, 0x14, 0x36,
0x14, 0x2d, 0x14, 0x32, 0x14, 0x36, 0x14, 0x2c,
0x14, 0x30, 0x14, 0x36, 0x14, 0x2c, 0x14, 0x31,
0x14, 0x34, 0x14, 0x2c, 0x14, 0x31, 0x14, 0x33,
0x14, 0x2a, 0x14, 0x30, 0x14, 0x33, 0x14, 0xfe,
0x30, 0x75, 0x2c, 0x14, 0x2f, 0x14, 0x34, 0x14,
0xfc, 0x04, 0x04, 0xf7, 0x2b, 0x14, 0x2f, 0x14,
0x34, 0x14, 0xfc, 0x04, 0x04, 0xf7, 0x2b, 0x14,
0x2f, 0x14, 0x35, 0x14, 0xfc, 0x04, 0x04, 0xf7,
0x2b, 0x14, 0x30, 0x14, 0x34, 0x14, 0x2b, 0x14,
0x30, 0x14, 0x34, 0x14, 0x2b, 0x14, 0x31, 0x14,
0x34, 0x14, 0x2a, 0x14, 0x31, 0x14, 0x34, 0x14,
0x2a, 0x14, 0x2f, 0x14, 0x32, 0x14, 0x2a, 0x14,
0x2f, 0x14, 0x32, 0x14, 0x2b, 0x14, 0x2f, 0x14,
0x31, 0x14, 0x28, 0x14, 0x2f, 0x14, 0x31, 0x14,
0x2a, 0x14, 0x2f, 0x14, 0x32, 0x14, 0x2a, 0x14,
0x2f, 0x14, 0x32, 0x14, 0x2a, 0x14, 0x2e, 0x14,
0x31, 0x14, 0x2a, 0x14, 0x2e, 0x14, 0x31, 0x14,
0x2f, 0x14, 0x32, 0x14, 0x36, 0x14, 0x2f, 0x14,
0x32, 0x14, 0x36, 0x14, 0x2f, 0x14, 0x33, 0x14,
0x36, 0x14, 0x2f, 0x14, 0x33, 0x14, 0x36, 0x14,
0x2f, 0x14, 0x34, 0x14, 0x37, 0x14, 0xfc, 0x04,
0x04, 0xf7, 0x2f, 0x14, 0x33, 0x14, 0x36, 0x14,
0xfc, 0x04, 0x04, 0xf7, 0x2f, 0x14, 0x34, 0x14,
0x37, 0x14, 0xfc, 0x04, 0x04, 0xf7, 0x2f, 0x14,
0x33, 0x14, 0x36, 0x14, 0x2f, 0x14, 0x33, 0x14,
0x36, 0x14, 0x2f, 0x14, 0x32, 0x14, 0x35, 0x14,
0x2f, 0x14, 0x32, 0x14, 0x35, 0x14, 0x2f, 0x14,
0x31, 0x14, 0x38, 0x14, 0x2f, 0x14, 0x31, 0x14,
0x38, 0x14, 0x2d, 0x14, 0x31, 0x14, 0x36, 0x14,
0x2d, 0x14, 0x31, 0x14, 0x36, 0x14, 0x2b, 0x14,
0x2f, 0x14, 0x32, 0x14, 0x2b, 0x14, 0x2f, 0x14,
0x32, 0x14, 0x2a, 0x14, 0x2d, 0x14, 0x33, 0x14,
0x2a, 0x14, 0x2d, 0x14, 0x33, 0x14, 0x25, 0x14,
0x2a, 0x14, 0x2d, 0x14, 0x25, 0x14, 0x2a, 0x14,
0x2d, 0x14, 0x25, 0x14, 0x2a, 0x14, 0x2c, 0x14,
0x25, 0x14, 0x29, 0x14, 0x2c, 0x14, 0x2a, 0x14,
0x2d, 0x14, 0x31, 0x14, 0x2d, 0x14, 0x31, 0x14,
0x36, 0x14, 0x31, 0x14, 0x36, 0x14, 0x39, 0x14,
0x31, 0x14, 0x36, 0x14, 0x39, 0x14, 0x31, 0x14,
0x38, 0x14, 0x3b, 0x14, 0xfc, 0x04, 0x04, 0xf7,
0x31, 0x14, 0x36, 0x14, 0x39, 0x14, 0x31, 0x14,
0x36, 0x14, 0x39, 0x14, 0x30, 0x14, 0x36, 0x14,
0x39, 0x14, 0x31, 0x14, 0x36, 0x14, 0x39, 0x14,
0x33, 0x14, 0x36, 0x14, 0x38, 0x14, 0xfc, 0x04,
0x04, 0xf7, 0x34, 0x14, 0x38, 0x14, 0x3d, 0x14,
0x34, 0x14, 0x38, 0x14, 0x3d, 0x14, 0x33, 0x14,
0x36, 0x14, 0x39, 0x14, 0x31, 0x14, 0x34, 0x14,
0x3a, 0x14, 0x3c, 0x14, 0x30, 0x14, 0x33, 0x14,
0x38, 0x14, 0x30, 0x14, 0x33, 0x14, 0x39, 0x14,
0x30, 0x14, 0x33, 0x14, 0x36, 0x14, 0x30, 0x14,
0x33, 0x14, 0x00, 0x14, 0x30, 0x14, 0x33, 0x14,
0x2c, 0x14, 0x30, 0x14, 0x33, 0x14, 0x2d, 0x14,
0x30, 0x14, 0x33, 0x14, 0x2a, 0x14, 0x30, 0x14,
0x33, 0x14, 0x28, 0x14, 0x34, 0x14, 0x38, 0x14,
0x3d, 0x14, 0x34, 0x14, 0x38, 0x14, 0x40, 0x14,
0x34, 0x14, 0x38, 0x14, 0x3d, 0x14, 0x34, 0x14,
0x38, 0x14, 0x00, 0x14, 0x28, 0x14, 0x2c, 0x14,
0x31, 0x14, 0x28, 0x14, 0x2c, 0x14, 0x34, 0x14,
0x28, 0x14, 0x2c, 0x14, 0x31, 0x14, 0x28, 0x14,
0x2c, 0x14, 0x27, 0x14, 0x2d, 0x14, 0x2a, 0x14,
0x30, 0x14, 0x2d, 0x14, 0x33, 0x14, 0x30, 0x14,
0x36, 0x14, 0x33, 0x14, 0x39, 0x14, 0x36, 0x14,
0x3c, 0x14, 0x28, 0x14, 0x31, 0x14, 0x2c, 0x14,
0x34, 0x14, 0x31, 0x14, 0x38, 0x14, 0x34, 0x14,
0x3d, 0x14, 0x38, 0x14, 0x40, 0x14, 0x3d, 0x14,
0x38, 0x14, 0x31, 0x14, 0x37, 0x14, 0x34, 0x14,
0x3a, 0x14, 0x37, 0x14, 0x3d, 0x14, 0x3a, 0x14,
0x40, 0x14, 0x3d, 0x14, 0x43, 0x14, 0x40, 0x14,
0x46, 0x14, 0x36, 0x14, 0x3c, 0x14, 0x39, 0x14,
0x3f, 0x14, 0x3c, 0x14, 0x42, 0x14, 0x3f, 0x14,
0x45, 0x14, 0x42, 0x14, 0x48, 0x14, 0x45, 0x14,
0x4b, 0x14, 0x48, 0x14, 0x42, 0x14, 0x45, 0x14,
0x3f, 0x14, 0x42, 0x14, 0x3c, 0x14, 0x3f, 0x14,
0x39, 0x14, 0x3c, 0x14, 0x36, 0x14, 0x39, 0x14,
0x33, 0x14, 0x36, 0x14, 0x30, 0x14, 0x33, 0x14,
0x2d, 0x14, 0x30, 0x14, 0x2a, 0x14, 0x2d, 0x14,
0x27, 0x14, 0x2a, 0x14, 0x25, 0x14, 0x2a, 0x14,
0x2d, 0x14, 0x24, 0x14, 0x2a, 0x14, 0x2c, 0x14,
0x2d, 0x14, 0x2c, 0x14, 0x2a, 0x14, 0x27, 0x14,
0x2a, 0x14, 0x2d, 0x14, 0x25, 0x14, 0x2a, 0x14,
0x2d, 0x14, 0x24, 0x14, 0x2a, 0x14, 0x2c, 0x14,
0x2d, 0x14, 0x2c, 0x14, 0x2a, 0x14, 0x26, 0x14,
0x2a, 0x14, 0x2d, 0x14, 0x25, 0x14, 0x2a, 0x14,
0x2d, 0x14, 0x24, 0x14, 0x2a, 0x14, 0x2c, 0x14,
0x2d, 0x14, 0x2c, 0x14, 0x2a, 0x14, 0x25, 0x14,
0x28, 0x14, 0x31, 0x14, 0x25, 0x14, 0x28, 0x14,
0x31, 0x14, 0x27, 0x14, 0x2d, 0x14, 0x31, 0x14,
0x27, 0x14, 0x2d, 0x14, 0x31, 0x14, 0x27, 0x14,
0x2c, 0x14, 0x30, 0x14, 0x27, 0x14, 0x2c, 0x14,
0x30, 0x14, 0xfe, 0x30, 0x75, 0x2c, 0x14, 0x2f,
0x14, 0x34, 0x14, 0x2f, 0x14, 0x34, 0x14, 0x38,
0x14, 0xfc, 0x03, 0x03, 0xf7, 0x2f, 0x14, 0x36,
0x14, 0x39, 0x14, 0xfc, 0x04, 0x04, 0xf7, 0x2f,
0x14, 0x34, 0x14, 0x38, 0x14, 0x2f, 0x14, 0x34,
0x14, 0x38, 0x14, 0x30, 0x14, 0x36, 0x14, 0x38,
0x14, 0x31, 0x14, 0x34, 0x14, 0x38, 0x14, 0x33,
0x14, 0x36, 0x14, 0x38, 0x14, 0x33, 0x14, 0x36,
0x14, 0x38, 0x14, 0x34, 0x14, 0x38, 0x14, 0x3d,
0x14, 0x34, 0x14, 0x38, 0x14, 0x3d, 0x14, 0x32,
0x14, 0x36, 0x14, 0x39, 0x14, 0x32, 0x14, 0x36,
0x14, 0x39, 0x14, 0x30, 0x14, 0x36, 0x14, 0x38,
0x14, 0x30, 0x14, 0x36, 0x14, 0x38, 0x14, 0x31,
0x14, 0x34, 0x14, 0x38, 0x14, 0x31, 0x14, 0x34,
0x14, 0x38, 0x14, 0x31, 0x14, 0x35, 0x14, 0x38,
0x14, 0x31, 0x14, 0x35, 0x14, 0x38, 0x14, 0x31,
0x14, 0x36, 0x14, 0x39, 0x14, 0xfc, 0x04, 0x04,
0xf7, 0x31, 0x14, 0x35, 0x14, 0x38, 0x14, 0xfc,
0x04, 0x04, 0xf7, 0x31, 0x14, 0x36, 0x14, 0x39,
0x14, 0xfc, 0x04, 0x04, 0xf7, 0x31, 0x14, 0x35,
0x14, 0x38, 0x14, 0x31, 0x14, 0x35, 0x14, 0x38,
0x14, 0x31, 0x14, 0x36, 0x14, 0x39, 0x14, 0x31,
0x14, 0x36, 0x14, 0x39, 0x14, 0x2f, 0x14, 0x36,
0x14, 0x39, 0x14, 0xfc, 0x03, 0x03, 0xf7, 0x2f,
0x14, 0x34, 0x14, 0x38, 0x14, 0x2d, 0x14, 0x34,
0x14, 0x38, 0x14, 0x2d, 0x14, 0x33, 0x14, 0x36,
0x14, 0x2c, 0x14, 0x33, 0x14, 0x36, 0x14, 0x2c,
0x14, 0x31, 0x14, 0x34, 0x14, 0x2a, 0x14, 0x31,
0x14, 0x33, 0x14, 0x2a, 0x14, 0x31, 0x14, 0x33,
0x14, 0x2c, 0x14, 0x31, 0x14, 0x33, 0x14, 0x2d,
0x14, 0x31, 0x14, 0x33, 0x14, 0x2c, 0x14, 0x31,
0x14, 0x34, 0x14, 0x2c, 0x14, 0x31, 0x14, 0x34,
0x14, 0x2a, 0x14, 0x30, 0x14, 0x33, 0x14, 0x2a,
0x14, 0x30, 0x14, 0x33, 0x14, 0x28, 0x14, 0x2c,
0x14, 0x31, 0x14, 0x2c, 0x14, 0x31, 0x14, 0x34,
0x14, 0xfc, 0x03, 0x03, 0xf7, 0x2c, 0x14, 0x33,
0x14, 0x36, 0x14, 0xfc, 0x04, 0x04, 0xf7, 0x2c,
0x14, 0x34, 0x14, 0x31, 0x14, 0x38, 0x14, 0x34,
0x14, 0x3d, 0x14, 0x38, 0x14, 0x40, 0x14, 0x3d,
0x14, 0x44, 0x14, 0x40, 0x14, 0x3d, 0x14, 0x3c,
0x14, 0x3f, 0x14, 0x39, 0x14, 0x3c, 0x14, 0x36,
0x14, 0x39, 0x14, 0x33, 0x14, 0x36, 0x14, 0x2d,
0x28, 0x2c, 0x14, 0x2a, 0x14, 0x28, 0x14, 0xfc,
0x02, 0x02, 0xcf, 0x2c, 0x14, 0x31, 0x14, 0x34,
0x14, 0x31, 0x14, 0x2c, 0x14, 0x00, 0x14, 0x28,
0x14, 0x2c, 0x14, 0x31, 0x14, 0x2c, 0x14, 0x28,
0x14, 0x00, 0x14, 0x25, 0x14, 0x28, 0x14, 0x2c,
0x14, 0x28, 0x14, 0x25, 0x14, 0x20, 0x14, 0x25,
0x14, 0x20, 0x14, 0x1c, 0x14, 0x20, 0x14, 0x1c,
0x14, 0x19, 0x78, 0x31, 0x78, 0x31, 0xf0, 0xff,
0xfb, 0x08, 0x19, 0xf0, 0x17, 0xf0, 0x15, 0x78,
0x12, 0x78, 0x14, 0x78, 0x14, 0x78, 0x19, 0xf0,
0x18, 0xf0, 0x19, 0x78, 0x1e, 0x78, 0x17, 0x78,
0x17, 0x78, 0x1c, 0xf0, 0x1c, 0xf0, 0x1a, 0xf0,
0x18, 0x3c, 0x17, 0x3c, 0x16, 0x78, 0x17, 0x78,
0x1c, 0x3c, 0x1f, 0x3c, 0x1e, 0x78, 0x12, 0x78,
0x17, 0xf0, 0x17, 0x3c, 0x1c, 0x3c, 0x1f, 0x3c,
0x1c, 0x3c, 0xfc, 0x02, 0x02, 0xf3, 0x17, 0x78,
0x20, 0x78, 0x1d, 0x78, 0x1e, 0x78, 0x17, 0x78,
0x18, 0x78, 0x19, 0x78, 0x19, 0x78, 0x12, 0xf0,
0x1d, 0xf0, 0x1e, 0x78, 0x1b, 0x3c, 0x19, 0x3c,
0x18, 0xb4, 0x18, 0x3c, 0x19, 0x78, 0x1e, 0x3c,
0x1f, 0x3c, 0x20, 0xf0, 0xfc, 0x0c, 0x0c, 0xfb,
0x20, 0x78, 0x21, 0x78, 0x1e, 0x78, 0x20, 0x78,
0x19, 0xf0, 0x18, 0xf0, 0x19, 0x78, 0x1e, 0x78,
0x17, 0x78, 0x17, 0x78, 0x1c, 0xf0, 0x1b, 0xf0,
0x1c, 0x78, 0x1b, 0x3c, 0x19, 0x3c, 0x18, 0x78,
0x19, 0x78, 0x1e, 0x78, 0x20, 0x78, 0x19, 0xf0,
0x19, 0x3c, 0x1e, 0x3c, 0x21, 0x3c, 0x1e, 0x3c,
0xfc, 0x02, 0x02, 0xf3, 0x19, 0x78, 0x1e, 0x78,
0x1b, 0xb4, 0x1c, 0x3c, 0x19, 0x3c, 0x1b, 0x3c,
0x18, 0x3c, 0x19, 0x3c, 0x21, 0x78, 0x20, 0x3c,
0x1e, 0x3c, 0x20, 0x78, 0x20, 0x78, 0x19, 0xf0,
0x18, 0xf0, 0x19, 0xf0, 0x14, 0xb4, 0x30, 0x3c,
0x19, 0xf0, 0x14, 0xb4, 0x30, 0x3c, 0x19, 0xdc,
0x19, 0x8c, 0x00, 0xf0, 0x19, 0x78, 0x19, 0xf0,
0xff, 0xfb, 0x08, 0x25, 0xf0, 0x23, 0xf0, 0x21,
0x78, 0x1e, 0x78, 0x20, 0x78, 0x20, 0x78, 0x20,
0xb4, 0x38, 0x2d, 0x38, 0x0f, 0x38, 0xb4, 0x38,
0x2d, 0x38, 0x0f, 0x38, 0x78, 0x39, 0x78, 0x38,
0x78, 0x36, 0x3c, 0x3b, 0x3c, 0x34, 0x3c, 0x00,
0xb4, 0x28, 0xb4, 0x37, 0x2d, 0x37, 0x0f, 0x37,
0xb4, 0xfc, 0x02, 0x02, 0xf7, 0x36, 0x3c, 0x36,
0x78, 0x37, 0x3c, 0x34, 0x3c, 0x36, 0x78, 0x36,
0x78, 0x2f, 0x3c, 0x00, 0x78, 0x3b, 0x3c, 0x3c,
0xb4, 0x3a, 0x3c, 0x3b, 0xb4, 0x3b, 0x3c, 0x3c,
0xb4, 0x3a, 0x3c, 0x3b, 0x78, 0x3b, 0x78, 0x3b,
0x78, 0x39, 0x78, 0x37, 0x78, 0x36, 0x78, 0x31,
0x78, 0x31, 0x3c, 0x31, 0x3c, 0x00, 0xb4, 0x3d,
0x2d, 0x3d, 0x0f, 0x3d, 0xb4, 0x3d, 0x2d, 0x3d,
0x0f, 0x3d, 0x78, 0x3c, 0x3c, 0x3d, 0x3c, 0x3f,
0xb4, 0x3f, 0x3c, 0x40, 0x78, 0x3f, 0x3c, 0x3d,
0x3c, 0x14, 0xf0, 0xfc, 0x09, 0x09, 0xfb, 0x14,
0x8c, 0x27, 0x28, 0x25, 0x3c, 0x24, 0x78, 0x27,
0x3c, 0x25, 0x3c, 0x24, 0x78, 0x26, 0x3c, 0x25,
0x3c, 0x24, 0x78, 0x15, 0x78, 0x12, 0x78, 0x14,
0x78, 0x20, 0xb4, 0x38, 0x2d, 0x38, 0x0f, 0x38,
0xb4, 0x38, 0x2d, 0x38, 0x0f, 0x38, 0x78, 0x39,
0x78, 0x38, 0x78, 0x36, 0x3c, 0x3b, 0x3c, 0x34,
0x3c, 0x00, 0x78, 0x3b, 0x2d, 0x3b, 0x0f, 0x3b,
0xb4, 0x3b, 0x2d, 0x3b, 0x0f, 0x3b, 0x78, 0x3c,
0x3c, 0x3d, 0x3c, 0x3f, 0x78, 0x40, 0x78, 0x3e,
0x78, 0x3c, 0x78, 0x3d, 0xb4, 0x3d, 0x3c, 0x3e,
0xb4, 0x3c, 0x3c, 0xfc, 0x02, 0x02, 0xf5, 0x3d,
0x78, 0x3d, 0x78, 0x3b, 0xb4, 0x3b, 0x3c, 0x39,
0x3c, 0x39, 0x3c, 0x38, 0x3c, 0x38, 0x3c, 0x36,
0x78, 0x38, 0x3c, 0x39, 0x3c, 0x38, 0x78, 0x38,
0x78, 0x31, 0x3c, 0x00, 0x78, 0x20, 0x2d, 0x20,
0x0f, 0x20, 0xb4, 0xfc, 0x05, 0x05, 0xf7, 0x20,
0x2d, 0x20, 0x0f, 0x20, 0x78, 0x25, 0x78, 0x20,
0x78, 0x00, 0xf0, 0x28, 0x78, 0x28, 0xf0, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x06, 0xf7, 0x37, 0xf7, 0x68, 0xf7, 0xfb, 0x07,
0x32, 0x40, 0x2b, 0x40, 0x2d, 0x40, 0x2f, 0x80,
0x2b, 0x40, 0x2d, 0x40, 0x26, 0x80, 0x32, 0x20,
0x31, 0x20, 0x2f, 0x20, 0x2d, 0x20, 0x2b, 0x20,
0x2d, 0x20, 0x2f, 0x60, 0x2d, 0x20, 0x2b, 0x20,
0x28, 0x24, 0x2d, 0x28, 0x21, 0x2c, 0x2b, 0x32,
0x2a, 0x1e, 0x28, 0x24, 0x26, 0xc8, 0xff, 0xfb,
0x06, 0x39, 0x20, 0x39, 0x20, 0x3b, 0x40, 0x3d,
0x40, 0x3e, 0x80, 0x3b, 0x40, 0x3d, 0x40, 0x36,
0x80, 0x39, 0x20, 0x39, 0x20, 0x3b, 0x20, 0x3e,
0x20, 0x3b, 0x20, 0x3d, 0x20, 0x3e, 0x80, 0x3b,
0x20, 0x3b, 0x24, 0x3d, 0x28, 0x37, 0x2c, 0x3b,
0x32, 0x39, 0x1e, 0x37, 0x24, 0x36, 0xc8, 0xff,
0xfb, 0x08, 0x42, 0x20, 0x42, 0x10, 0x3e, 0x10,
0x43, 0x20, 0x42, 0x20, 0x40, 0x20, 0x45, 0x10,
0x43, 0x10, 0x42, 0x80, 0x3e, 0x20, 0x43, 0x20,
0x40, 0x20, 0x3e, 0x10, 0x3d, 0x10, 0x3e, 0x40,
0x3e, 0x40, 0x42, 0x20, 0x42, 0x10, 0x3e, 0x10,
0x43, 0x20, 0x42, 0x20, 0x40, 0x20, 0x45, 0x10,
0x43, 0x10, 0x42, 0x80, 0x3e, 0x20, 0x43, 0x24,
0x40, 0x28, 0x3e, 0x14, 0x3d, 0x18, 0x3e, 0x74,
0x3e, 0xc8, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa, 0xfa,
0xfa, 0xfa, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x21, 0x0d, 0x0e, 0x22, 0xb1, 0xfe, 0x3e, 0x0f,
0x32, 0xb3, 0xfe, 0x01, 0xfd, 0xff, 0xed, 0x43,
0xb9, 0xfe, 0xaf, 0xed, 0x79, 0x06, 0xbf, 0xed,
0x43, 0xbb, 0xfe, 0x3e, 0x7b, 0xed, 0x79, 0x21,
0x6e, 0xfe, 0x22, 0xbd, 0xfe, 0x2a, 0x88, 0xfe,
0x22, 0x8a, 0xfe, 0x06, 0xff, 0xed, 0x78, 0xfe,
0x7b, 0x28, 0x43, 0x21, 0x06, 0x07, 0x22, 0xb1,
0xfe, 0x3e, 0x08, 0x32, 0xb3, 0xfe, 0x01, 0xdd,
0x00, 0xed, 0x43, 0xb9, 0xfe, 0xaf, 0xed, 0x79,
0x21, 0x56, 0xfe, 0x22, 0xbd, 0xfe, 0x2a, 0x86,
0xfe, 0x22, 0x8a, 0xfe, 0x01, 0xdf, 0x00, 0xed,
0x43, 0xbb, 0xfe, 0x3e, 0x7b, 0xed, 0x79, 0x01,
0xdd, 0x00, 0xed, 0x78, 0xfe, 0x7b, 0x28, 0x0e,
0x3e, 0xfe, 0xcd, 0x01, 0x16, 0x11, 0xfd, 0xfa,
0xaf, 0xcd, 0x0a, 0x0c, 0xcf, 0x08, 0x21, 0x01,
0x01, 0x22, 0x52, 0xfe, 0x22, 0x53, 0xfe, 0x21,
0x8c, 0xfe, 0x11, 0x9c, 0xfe, 0x01, 0x10, 0x00,
0xed, 0xb0, 0x21, 0x00, 0xf8, 0x11, 0x01, 0xf8,
0x01, 0x01, 0x01, 0x36, 0xfa, 0xed, 0xb0, 0x16,
0x07, 0x7a, 0x3d, 0xed, 0x4b, 0xb9, 0xfe, 0xed,
0x79, 0xaf, 0xed, 0x4b, 0xbb, 0xfe, 0xed, 0x79,
0x15, 0x20, 0xee, 0xed, 0x4b, 0xb9, 0xfe, 0xed,
0x79, 0x3e, 0x19, 0xcd, 0x2e, 0xfd, 0x3e, 0x07,
0xed, 0x4b, 0xb9, 0xfe, 0xed, 0x79, 0xed, 0x78,
0xe6, 0xf8, 0xed, 0x4b, 0xbb, 0xfe, 0xed, 0x79,
0x3e, 0xf8, 0xed, 0x47, 0xed, 0x5e, 0xfb, 0xc9,
0x32, 0xac, 0xfe, 0x87, 0x5f, 0x16, 0x00, 0x21,
0x9c, 0xfe, 0x19, 0x22, 0xaf, 0xfe, 0x5e, 0x23,
0x56, 0xeb, 0x7e, 0x3c, 0xca, 0xf3, 0xfb, 0x3d,
0x20, 0x49, 0x4f, 0x23, 0x7e, 0x23, 0x47, 0xf6,
0x01, 0xc3, 0xf3, 0xfb, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0xc3, 0xfb, 0xfb, 0x80, 0x53, 0x6f,
0x72, 0x72, 0x79, 0x2c, 0x20, 0x49, 0x20, 0x63,
0x61, 0x6e, 0x27, 0x74, 0x20, 0x73, 0x65, 0x65,
0x6d, 0x20, 0x74, 0x6f, 0x20, 0x66, 0x69, 0x6e,
0x64, 0x20, 0x74, 0x68, 0x65, 0x20, 0x73, 0x6f,
0x75, 0x6e, 0x64, 0x20, 0x63, 0x68, 0x69, 0x70,
0x21, 0x8d, 0x23, 0x7e, 0x23, 0xcd, 0x2e, 0xfd,
0xc3, 0xe2, 0xfa, 0xfe, 0xf9, 0x30, 0x08, 0x4f,
0x23, 0x7e, 0x47, 0x23, 0xc3, 0xf3, 0xfb, 0xfe,
0xfd, 0x28, 0x2c, 0xda, 0xa2, 0xfb, 0x23, 0x5e,
0x23, 0x56, 0x23, 0xed, 0x53, 0xad, 0xfe, 0xe5,
0x3a, 0xac, 0xfe, 0x87, 0x5f, 0x16, 0x00, 0x21,
0xa4, 0xfe, 0x19, 0x5e, 0x23, 0x56, 0xe3, 0xeb,
0x73, 0x23, 0x72, 0x23, 0xeb, 0xe1, 0x72, 0x2b,
0x73, 0x2a, 0xad, 0xfe, 0xc3, 0xe2, 0xfa, 0x3a,
0xac, 0xfe, 0x87, 0x5f, 0x16, 0x00, 0x21, 0xa4,
0xfe, 0x19, 0x5e, 0x23, 0x56, 0xeb, 0x2b, 0x46,
0x2b, 0x4e, 0xeb, 0x72, 0x2b, 0x73, 0x60, 0x69,
0xc3, 0xe2, 0xfa, 0x23, 0x35, 0x28, 0x09, 0x23,
0x23, 0x5e, 0x16, 0xff, 0x19, 0xc3, 0xe2, 0xfa,
0x23, 0x7e, 0x2b, 0x77, 0x23, 0x23, 0x23, 0xc3,
0xe2, 0xfa, 0xfe, 0xfc, 0x28, 0xe5, 0xfe, 0xfa,
0xca, 0x2a, 0xfb, 0x38, 0x3d, 0x23, 0x3a, 0xac,
0xfe, 0xe5, 0x5f, 0x16, 0x00, 0x21, 0xb0, 0xfe,
0x19, 0xeb, 0xe1, 0x7e, 0xed, 0xa0, 0x5f, 0x3a,
0xac, 0xfe, 0x47, 0x3e, 0x84, 0x0e, 0x7f, 0xcb,
0x7b, 0x28, 0x02, 0x0e, 0xfb, 0x07, 0xcb, 0x01,
0x10, 0xfb, 0x47, 0x3e, 0x07, 0xc5, 0xed, 0x4b,
0xb9, 0xfe, 0xed, 0x79, 0xed, 0x78, 0xc1, 0xb0,
0xa1, 0xed, 0x4b, 0xbb, 0xfe, 0xed, 0x79, 0xc3,
0xe2, 0xfa, 0x23, 0x7e, 0x23, 0x32, 0x55, 0xfe,
0xc3, 0xe2, 0xfa, 0xeb, 0x2a, 0xaf, 0xfe, 0x73,
0x23, 0x72, 0xc9, 0x00, 0xf3, 0xf5, 0x3a, 0xfb,
0x85, 0xfe, 0x08, 0x20, 0x1d, 0x3e, 0x3e, 0xed,
0x47, 0x00, 0x00, 0x3e, 0x07, 0xc5, 0xed, 0x4b,
0xb9, 0xfe, 0xed, 0x79, 0xed, 0x78, 0xf6, 0x07,
0xed, 0x4b, 0xbb, 0xfe, 0xed, 0x79, 0xc1, 0xf1,
0xf3, 0xc9, 0xe5, 0xd5, 0xc5, 0x06, 0x03, 0x21,
0x54, 0xfe, 0x7e, 0xa7, 0x28, 0x31, 0x35, 0x28,
0x41, 0x7e, 0x3d, 0x20, 0x2a, 0xe5, 0x58, 0x16,
0x00, 0x21, 0xb0, 0xfe, 0x19, 0x7e, 0x2f, 0xe6,
0x80, 0x28, 0x01, 0x78, 0xcd, 0x69, 0xfd, 0x7e,
0xe6, 0x10, 0xe1, 0x20, 0x12, 0x78, 0xc6, 0x07,
0x58, 0xed, 0x4b, 0xb9, 0xfe, 0xed, 0x79, 0xaf,
0xed, 0x4b, 0xbb, 0xfe, 0xed, 0x79, 0x43, 0x2b,
0x10, 0xc8, 0x21, 0x52, 0xfe, 0x7e, 0x23, 0xb6,
0x23, 0xb6, 0xc1, 0xd1, 0xe1, 0x28, 0x96, 0xf1,
0xfb, 0xc9, 0xe5, 0xc5, 0x78, 0xcd, 0xd0, 0xfa,
0x20, 0x04, 0xc1, 0xe1, 0x18, 0xe1, 0x79, 0xb7,
0x20, 0x06, 0xe1, 0xe3, 0x70, 0xc1, 0x18, 0xd7,
0x3a, 0xac, 0xfe, 0x5f, 0x16, 0x00, 0x21, 0xb0,
0xfe, 0x19, 0x7e, 0x32, 0xb4, 0xfe, 0x2f, 0xe6,
0x80, 0xf5, 0x28, 0x01, 0x7b, 0xcd, 0x8b, 0xfd,
0xf1, 0x20, 0x15, 0x3e, 0x06, 0x50, 0x59, 0xed,
0x4b, 0xb9, 0xfe, 0xed, 0x79, 0x7b, 0xed, 0x4b,
0xbb, 0xfe, 0xed, 0x79, 0xe1, 0x4a, 0x18, 0x46,
0x79, 0x48, 0x06, 0x00, 0xfe, 0x0c, 0x38, 0x05,
0xd6, 0x0c, 0x04, 0x18, 0xf7, 0x6f, 0x26, 0x00,
0x29, 0xed, 0x5b, 0xbd, 0xfe, 0x19, 0x5e, 0x23,
0x56, 0x78, 0xa7, 0x28, 0x06, 0xcb, 0x3a, 0xcb,
0x1b, 0x10, 0xfa, 0xe1, 0x7c, 0x87, 0x3d, 0x6f,
0xc5, 0xed, 0x4b, 0xb9, 0xfe, 0xed, 0x79, 0x7a,
0xed, 0x4b, 0xbb, 0xfe, 0xed, 0x79, 0x7d, 0x3d,
0xed, 0x4b, 0xb9, 0xfe, 0xed, 0x79, 0x7b, 0xed,
0x4b, 0xbb, 0xfe, 0xed, 0x79, 0xc1, 0x7c, 0xc6,
0x07, 0x59, 0xed, 0x4b, 0xb9, 0xfe, 0xed, 0x79,
0x3a, 0xb4, 0xfe, 0xed, 0x4b, 0xbb, 0xfe, 0xed,
0x79, 0xe6, 0x10, 0x28, 0x13, 0xc5, 0x3e, 0x0d,
0xed, 0x4b, 0xb9, 0xfe, 0xed, 0x79, 0xed, 0x4b,
0xbb, 0xfe, 0x3a, 0x55, 0xfe, 0xed, 0x79, 0xc1,
0xe3, 0x73, 0xc1, 0xc3, 0x5f, 0xfc, 0xd5, 0xc5,
0xe5, 0xed, 0x5b, 0x8a, 0xfe, 0x06, 0x08, 0x21,
0x00, 0x00, 0x29, 0x38, 0x08, 0x17, 0x30, 0x03,
0x19, 0x38, 0x02, 0x10, 0xf5, 0xcb, 0x3c, 0xcb,
0x1d, 0x3e, 0x0b, 0xed, 0x4b, 0xb9, 0xfe, 0xed,
0x79, 0xed, 0x4b, 0xbb, 0xfe, 0xed, 0x69, 0xed,
0x4b, 0xb9, 0xfe, 0x3e, 0x0c, 0xed, 0x79, 0xed,
0x4b, 0xbb, 0xfe, 0xed, 0x61, 0xe1, 0xc1, 0xd1,
0xc9, 0xe5, 0xd5, 0xc5, 0xf5, 0x3d, 0xe6, 0x0f,
0xf6, 0x80, 0xcd, 0xbd, 0xfd, 0xf1, 0xf5, 0x5f,
0x16, 0x00, 0x21, 0xb5, 0xfe, 0x19, 0x7e, 0xcd,
0xbd, 0xfd, 0xaf, 0xcd, 0xbd, 0xfd, 0xf1, 0xc1,
0xd1, 0xe1, 0xc9, 0xe5, 0xd5, 0xc5, 0xf5, 0x3d,
0xe6, 0x0f, 0xf6, 0x90, 0xcd, 0xbd, 0xfd, 0xf1,
0xc1, 0xc5, 0xf5, 0x5f, 0x16, 0x00, 0x21, 0xb5,
0xfe, 0x19, 0x79, 0xc6, 0x0c, 0x77, 0xcd, 0xbd,
0xfd, 0x3a, 0xb4, 0xfe, 0xe6, 0x1f, 0xfe, 0x10,
0x38, 0x02, 0x3e, 0x0a, 0x87, 0x87, 0x87, 0xcd,
0xbd, 0xfd, 0xc3, 0x86, 0xfd, 0x6f, 0xed, 0x4b,
0xb9, 0xfe, 0x78, 0x3c, 0xc0, 0x3e, 0x07, 0xed,
0x79, 0xed, 0x78, 0xf6, 0xc0, 0x06, 0xbf, 0xed,
0x79, 0x3e, 0x0e, 0x06, 0xff, 0xed, 0x79, 0x06,
0xbf, 0x3e, 0xfa, 0xed, 0x79, 0x1e, 0x03, 0x1d,
0x20, 0xfd, 0x00, 0x00, 0x00, 0x00, 0x7d, 0x16,
0x08, 0x1f, 0x6f, 0xd2, 0xf4, 0xfd, 0x3e, 0xfe,
0xed, 0x79, 0x18, 0x06, 0x3e, 0xfa, 0xed, 0x79,
0x18, 0x00, 0x1e, 0x02, 0x1d, 0x20, 0xfd, 0x00,
0xc6, 0x00, 0x7d, 0x15, 0x20, 0xe3, 0x00, 0x00,
0xc6, 0x00, 0x00, 0x00, 0x3e, 0xfe, 0xed, 0x79,
0x1e, 0x06, 0x1d, 0x20, 0xfd, 0xc9, 0x7a, 0x41,
0x7a, 0xe1, 0x75, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0xa5, 0x7a, 0x61, 0x7a, 0x09, 0x76, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xc5, 0x7a, 0x5e,
0x77, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x04, 0x68, 0x68, 0x00, 0x00, 0x17,
0xb8, 0x15, 0x80, 0x14, 0x58, 0x13, 0x40, 0x12,
0x38, 0x11, 0x40, 0x10, 0x58, 0x0f, 0x80, 0x0e,
0xb0, 0x0d, 0xe8, 0x0c, 0x30, 0x0c, 0x78, 0x1a,
0x00, 0x19, 0x98, 0x17, 0x48, 0x16, 0x08, 0x15,
0xd8, 0x13, 0xb8, 0x12, 0xb0, 0x11, 0xb0, 0x10,
0xc0, 0x0f, 0xe0, 0x0e, 0x08, 0x0e, 0xf1, 0x00,
0x15, 0x01, 0x15, 0x01, 0x00, 0x00, 0x7b, 0x75,
0xf0, 0x79, 0xc1, 0x7a, 0x00, 0x00, 0x16, 0xfe,
0x2a, 0xfe, 0x3e, 0xfe, 0x00, 0x00, 0x89, 0x75,
0xf8, 0x79, 0xc9, 0x7a, 0x00, 0x00, 0x16, 0xfe,
0x2a, 0xfe, 0x3e, 0xfe, 0x01, 0x00, 0x00, 0x9e,
0xfe, 0x09, 0x08, 0x08, 0x09, 0x00, 0x39, 0x21,
0x2d, 0xfd, 0xff, 0xfd, 0xbf, 0x6e, 0xfe, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0xdb, 0x02, 0x7c, 0x38, 0x98, 0xfd,
0x4d, 0x00, 0xdb, 0x02, 0x7c, 0x38, 0x98, 0xfd,
0x4d, 0x00, 0xa8, 0x57, 0x58, 0x00, 0xa7, 0x57,
0x8c, 0x08, 0x5c, 0x0e, 0x00, 0x47, 0xc0, 0x57,
0x71, 0x0e, 0x21, 0x17, 0x18, 0x00, 0x1e, 0x12,
0xff, 0xf9, 0x31, 0x10, 0x3a, 0x5b, 0x00, 0x3e,
0xb5, 0x3e, 0x99, 0x0d, 0xb5, 0x3e, 0x86, 0x26,
0x00, 0x3c, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x00,
0x00, 0x7c, 0x42, 0x7c, 0x42, 0x42, 0x7c, 0x00,
0x00, 0x3c, 0x42, 0x40, 0x40, 0x42, 0x3c, 0x00,
0x00, 0x78, 0x44, 0x42, 0x42, 0x44, 0x78, 0x00,
0x00, 0x7e, 0x40, 0x7c, 0x40, 0x40, 0x7e, 0x00,
0x00, 0x7e, 0x40, 0x7c, 0x40, 0x40, 0x40, 0x00,
0x00, 0x3c, 0x42, 0x40, 0x4e, 0x42, 0x3c, 0x00,
0x00, 0x42, 0x42, 0x7e, 0x42, 0x42, 0x42, 0x00,
0x00, 0x3e, 0x08, 0x08, 0x08, 0x08, 0x3e, 0x00,
0x00, 0x02, 0x02, 0x02, 0x42, 0x42, 0x3c, 0x00,
0x00, 0x44, 0x48, 0x70, 0x48, 0x44, 0x42, 0x00,
0x00, 0x40, 0x40, 0x40, 0x40, 0x40, 0x7e, 0x00,
0x00, 0x42, 0x66, 0x5a, 0x42, 0x42, 0x42, 0x00,
0x00, 0x42, 0x62, 0x52, 0x4a, 0x46, 0x42, 0x00,
0x00, 0x3c, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00,
0x00, 0x7c, 0x42, 0x42, 0x7c, 0x40, 0x40, 0x00,
0x00, 0x3c, 0x42, 0x42, 0x52, 0x4a, 0x3c, 0x00,
0x00, 0x7c, 0x42, 0x42, 0x7c, 0x44, 0x42, 0x00,
0x00, 0x3c, 0x40, 0x3c, 0x02, 0x42, 0x3c, 0x00,
0x00, 0xfe, 0x10, 0x10, 0x10, 0x10, 0x10, 0x00,
0x00, 0x42, 0x42, 0x42, 0x42, 0x42, 0x3c, 0x00,
};


jswByte title[] = 
{
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x03, 0x3f, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xff, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x3f, 0x00, 0x00, 0x00,
0x3f, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x3f, 0x00, 0x00, 0x00,
0x3f, 0xff, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x0f, 0x0f, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xff, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00,
0x0f, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00,
0x0f, 0xff, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x3f, 0x03, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xff, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00,
0x03, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00,
0x03, 0xff, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xff, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0xff, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x03, 0xff, 0x00, 0x3f, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x3f, 0x00, 0x00, 0x00, 0x3f,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x3f, 0x00, 0x00, 0x00, 0x3f, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f,
0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x0f, 0xff, 0x00, 0x0f, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x0f,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x0f, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f,
0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x3f, 0xff, 0x00, 0x03, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x03,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x03, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03,
0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x3f, 0xff, 0x00, 0x03, 0x00, 0x00, 0x00, 0x03,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x03, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0xfc, 0x00, 0x00, 0x00, 0x03, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x3f, 0xff, 0x00, 0x03, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0xf0, 0x00, 0x00, 0x00, 0x00, 0x00,
0x0f, 0xff, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x0f,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x0f, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0xf0, 0x00, 0x00, 0x00, 0x0f, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x0f, 0xff, 0x00, 0x0f, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x03, 0xff, 0x00, 0x3f, 0x00, 0x00, 0x00, 0x3f,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x3f, 0x00, 0x00, 0x00, 0x3f, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0xc0, 0x00, 0x00, 0x00, 0x3f, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x03, 0xff, 0x00, 0x3f, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0xff, 0x00, 0xff, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0xff, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0xff, 0x00, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x3f, 0x03, 0xff, 0x00, 0x00, 0x03, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x03, 0xff, 0x00, 0x00, 0x03, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
0x00, 0x00, 0x03, 0x00, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x03, 0x00, 0x00, 0x00, 0x03, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x03, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x03, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x3f, 0x03, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x0f, 0x0f, 0xff, 0x00, 0x00, 0x0f, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x0f, 0xff, 0x00, 0x00, 0x0f, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00,
0x00, 0x00, 0x0f, 0x00, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x0f, 0x00, 0x00, 0x00, 0x0f, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x0f, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x0f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x0f, 0x0f, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x03, 0x3f, 0xff, 0x00, 0x00, 0x3f, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x3f, 0xff, 0x00, 0x00, 0x3f, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f, 0x00,
0x00, 0x00, 0x3f, 0x00, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x3f, 0x00, 0x00, 0x00, 0x3f, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3f, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x3f, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x03, 0x3f, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0xff, 0xff, 0x00, 0x00, 0xff, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0xff, 0xff, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00,
0x00, 0x00, 0xff, 0x00, 0x00, 0x00, 0x00, 0xff,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0xff, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xff, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0xff, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0xff, 0xff, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x06, 0x06, 0x30, 0x30, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x05, 0x05, 0x05, 0xcd, 0xcd, 0xcd, 0x05,
0xcd, 0xcd, 0xcd, 0x16, 0xcd, 0xcd, 0xcd, 0x30,
0x05, 0x05, 0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd,
0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xcd, 0x05, 0x00,
0xcd, 0x05, 0x12, 0x12, 0x16, 0xcd, 0x36, 0x36,
0x30, 0x30, 0xcd, 0x00, 0x05, 0x00, 0xcd, 0x05,
0x00, 0x00, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xcd, 0x05, 0x05,
0xcd, 0xcd, 0x12, 0x12, 0x12, 0xcd, 0x16, 0x16,
0x36, 0x36, 0xcd, 0xcd, 0xcd, 0x00, 0xcd, 0xcd,
0x05, 0x00, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xcd, 0x00, 0x00,
0xcd, 0x05, 0x12, 0x12, 0x22, 0xcd, 0x12, 0x12,
0x16, 0x16, 0x36, 0x36, 0xcd, 0x30, 0xcd, 0x00,
0x05, 0x00, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x05, 0x05, 0x05, 0x05, 0xcd, 0xcd, 0x05, 0x05,
0xcd, 0xcd, 0xcd, 0x12, 0x24, 0xcd, 0x02, 0x02,
0x12, 0x12, 0xcd, 0xcd, 0xcd, 0x36, 0xcd, 0xcd,
0xcd, 0x05, 0x05, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x05, 0x00, 0x05, 0x05, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x12, 0x12, 0x24, 0x24, 0x00, 0x00,
0x02, 0x02, 0x16, 0x16, 0x36, 0x36, 0x34, 0x34,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x12, 0x12, 0x24, 0x24, 0x05, 0x00,
0x06, 0x06, 0x36, 0x36, 0x34, 0x34, 0x24, 0x24,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd,
0x00, 0xcd, 0x12, 0x12, 0x24, 0xcd, 0x06, 0xcd,
0x36, 0x36, 0x34, 0xcd, 0x24, 0x24, 0xcd, 0x20,
0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x05,
0x05, 0xcd, 0x00, 0xcd, 0x05, 0xcd, 0x00, 0xcd,
0x00, 0xcd, 0x12, 0x12, 0x24, 0xcd, 0x36, 0xcd,
0x34, 0x26, 0x24, 0xcd, 0x20, 0x20, 0xcd, 0x05,
0x05, 0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd, 0x05,
0x05, 0xcd, 0x00, 0xcd, 0x05, 0xcd, 0x00, 0xcd,
0x00, 0xcd, 0x12, 0x12, 0x24, 0xcd, 0x34, 0xcd,
0xcd, 0xcd, 0xcd, 0xcd, 0x00, 0x05, 0xcd, 0x00,
0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x00,
0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd, 0x00, 0xcd,
0x00, 0xcd, 0x12, 0x12, 0x24, 0xcd, 0x24, 0x24,
0x20, 0xcd, 0x05, 0x05, 0x05, 0x05, 0xcd, 0x00,
0xcd, 0x05, 0x05, 0x00, 0xcd, 0x05, 0xcd, 0x00,
0x05, 0xcd, 0xcd, 0xcd, 0xcd, 0xcd, 0x00, 0xcd,
0x05, 0xcd, 0xcd, 0xcd, 0x24, 0xcd, 0xcd, 0xcd,
0x05, 0xcd, 0x05, 0x05, 0x00, 0x00, 0xcd, 0x00,
0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x02, 0x02, 0x20, 0x20, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x04, 0x04, 0x20, 0x20, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x05, 0x05, 0x05, 0xcd, 0xcd, 0xcd, 0x05,
0xcd, 0xcd, 0xcd, 0x34, 0xcd, 0xcd, 0xcd, 0x20,
0x05, 0x05, 0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd,
0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xcd, 0x05, 0x00,
0xcd, 0x05, 0x36, 0x36, 0x34, 0xcd, 0x24, 0x24,
0x20, 0x20, 0xcd, 0x00, 0x05, 0x00, 0xcd, 0x05,
0x00, 0x00, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xcd, 0x05, 0x05,
0xcd, 0xcd, 0x36, 0x36, 0x36, 0xcd, 0x34, 0x34,
0x24, 0x24, 0xcd, 0xcd, 0xcd, 0x00, 0xcd, 0xcd,
0x05, 0x00, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xcd, 0x00, 0x00,
0xcd, 0x05, 0x36, 0x36, 0x16, 0xcd, 0x36, 0x36,
0x34, 0x34, 0x24, 0x24, 0xcd, 0x20, 0xcd, 0x00,
0x05, 0x00, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x05, 0x05, 0x05, 0x05, 0xcd, 0xcd, 0x05, 0x05,
0xcd, 0xcd, 0xcd, 0x36, 0x12, 0xcd, 0x06, 0x06,
0x36, 0x36, 0xcd, 0xcd, 0xcd, 0x24, 0xcd, 0xcd,
0xcd, 0x05, 0x05, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x05, 0x00, 0x05, 0x05, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x36, 0x36, 0x12, 0x12, 0x00, 0x00,
0x06, 0x06, 0x34, 0x34, 0x24, 0x24, 0x22, 0x22,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x36, 0x36, 0x12, 0x12, 0x05, 0x00,
0x04, 0x04, 0x24, 0x24, 0x22, 0x22, 0x12, 0x12,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd,
0x00, 0xcd, 0x36, 0x36, 0x12, 0xcd, 0x04, 0xcd,
0x24, 0x24, 0x22, 0xcd, 0x12, 0x12, 0xcd, 0x10,
0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x05,
0x05, 0xcd, 0x00, 0xcd, 0x05, 0xcd, 0x00, 0xcd,
0x00, 0xcd, 0x36, 0x36, 0x12, 0xcd, 0x24, 0xcd,
0x22, 0x14, 0x12, 0xcd, 0x10, 0x10, 0xcd, 0x05,
0x05, 0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd, 0x05,
0x05, 0xcd, 0x00, 0xcd, 0x05, 0xcd, 0x00, 0xcd,
0x00, 0xcd, 0x36, 0x36, 0x12, 0xcd, 0x22, 0xcd,
0xcd, 0xcd, 0xcd, 0xcd, 0x00, 0x05, 0xcd, 0x00,
0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x00,
0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd, 0x00, 0xcd,
0x00, 0xcd, 0x36, 0x36, 0x12, 0xcd, 0x12, 0x12,
0x10, 0xcd, 0x05, 0x05, 0x05, 0x05, 0xcd, 0x00,
0xcd, 0x05, 0x05, 0x00, 0xcd, 0x05, 0xcd, 0x00,
0x05, 0xcd, 0xcd, 0xcd, 0xcd, 0xcd, 0x00, 0xcd,
0x05, 0xcd, 0xcd, 0xcd, 0x12, 0xcd, 0xcd, 0xcd,
0x05, 0xcd, 0x05, 0x05, 0x00, 0x00, 0xcd, 0x00,
0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x06, 0x06, 0x10, 0x10, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x02, 0x02, 0x10, 0x10, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x05, 0x05, 0x05, 0xcd, 0xcd, 0xcd, 0x05,
0xcd, 0xcd, 0xcd, 0x22, 0xcd, 0xcd, 0xcd, 0x10,
0x05, 0x05, 0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd,
0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xcd, 0x05, 0x00,
0xcd, 0x05, 0x24, 0x24, 0x22, 0xcd, 0x12, 0x12,
0x10, 0x10, 0xcd, 0x00, 0x05, 0x00, 0xcd, 0x05,
0x00, 0x00, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xcd, 0x05, 0x05,
0xcd, 0xcd, 0x24, 0x24, 0x24, 0xcd, 0x22, 0x22,
0x12, 0x12, 0xcd, 0xcd, 0xcd, 0x00, 0xcd, 0xcd,
0x05, 0x00, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0xcd, 0x00, 0x00,
0xcd, 0x05, 0x24, 0x24, 0x34, 0xcd, 0x24, 0x24,
0x22, 0x22, 0x12, 0x12, 0xcd, 0x10, 0xcd, 0x00,
0x05, 0x00, 0x00, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x05, 0x05, 0x05, 0x05, 0xcd, 0xcd, 0x05, 0x05,
0xcd, 0xcd, 0xcd, 0x24, 0x36, 0xcd, 0x04, 0x04,
0x24, 0x24, 0xcd, 0xcd, 0xcd, 0x12, 0xcd, 0xcd,
0xcd, 0x05, 0x05, 0xcd, 0x00, 0x00, 0x00, 0x00,
0x05, 0x00, 0x05, 0x05, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x24, 0x24, 0x36, 0x36, 0x00, 0x00,
0x04, 0x04, 0x22, 0x22, 0x12, 0x12, 0x16, 0x16,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0x05, 0x24, 0x24, 0x36, 0x36, 0x05, 0x00,
0x02, 0x02, 0x12, 0x12, 0x16, 0x16, 0x36, 0x36,
0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05, 0x05,
0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd,
0x00, 0xcd, 0x24, 0x24, 0x36, 0xcd, 0x02, 0xcd,
0x12, 0x12, 0x16, 0xcd, 0x36, 0x36, 0xcd, 0x30,
0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x05,
0x05, 0xcd, 0x00, 0xcd, 0x05, 0xcd, 0x00, 0xcd,
0x00, 0xcd, 0x24, 0x24, 0x36, 0xcd, 0x12, 0xcd,
0x16, 0x32, 0x36, 0xcd, 0x30, 0x30, 0xcd, 0x05,
0x05, 0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd, 0x05,
0x05, 0xcd, 0x00, 0xcd, 0x05, 0xcd, 0x00, 0xcd,
0x00, 0xcd, 0x24, 0x24, 0x36, 0xcd, 0x16, 0xcd,
0xcd, 0xcd, 0xcd, 0xcd, 0x00, 0x05, 0xcd, 0x00,
0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x00,
0x05, 0xcd, 0x05, 0xcd, 0x05, 0xcd, 0x00, 0xcd,
0x00, 0xcd, 0x24, 0x24, 0x36, 0xcd, 0x36, 0x36,
0x30, 0xcd, 0x05, 0x05, 0x05, 0x05, 0xcd, 0x00,
0xcd, 0x05, 0x05, 0x00, 0xcd, 0x05, 0xcd, 0x00,
0x05, 0xcd, 0xcd, 0xcd, 0xcd, 0xcd, 0x00, 0xcd,
0x05, 0xcd, 0xcd, 0xcd, 0x36, 0xcd, 0xcd, 0xcd,
0x05, 0xcd, 0x05, 0x05, 0x00, 0x00, 0xcd, 0x00,
0xcd, 0xcd, 0xcd, 0x05, 0xcd, 0xcd, 0xcd, 0x00,
0x05, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x04, 0x04, 0x30, 0x30, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
0x00, 0x00, 0x00, 0x00, 0x00, 0x05, 0x00, 0x00,
};



